*  TRANAL v. > 3.1
*  Subroutines to compute order parameter / dipole couplings
*
*  Initialization
*
*======================= ORDERIN =====================================
*
      subroutine ORDERIN
      include "tranal.h"
      if(NEQH.le.0)then
        write(*,*)' Unacceptable number of CH bonds in order parameter',
     &' computations: ',NEQH
        stop
      end if
      if(NEQH.gt.NEQHM)then
        write(*,*)' Increase NEQHM in dimpar_tr.h'
        stop
      end if
      write(*,*)' Order parameter will be calculated for:'
      do J=1,NEQH
        write(*,'(a4,a1,a4,a,i5,a,i5)')
     +  NM(NC(J)),'-',NM(NH(J)),', or ',NC(J),' - ',NH(J)
        CSHL(J)=0.
        do N=1,NOP
	  SORD(N,J)=0
	end do
      end do
      return
      end
*
*======================== ORDERP =====================================
*
      subroutine ORDERP
      include "tranal.h"
      do J=1,NEQH
        ITYP=ITS(NC(J))
        NML=NSPEC(ITYP)
        do N=1,NML
	  IC = ISADDR(ITYP)+(N-1)*NSITS(ITYP)+NC(J)-ISADR(ITYP)
	  IH = ISADDR(ITYP)+(N-1)*NSITS(ITYP)+NH(J)-ISADR(ITYP)
          DX = SX(IH)-SX(IC)
          DY = SY(IH)-SY(IC)
          DZ = SZ(IH)-SZ(IC)
          call PBC(DX,DY,DZ)
          RR = sqrt(DX**2+DY**2+DZ**2)
          CSHL(J) = CSHL(J)+RR          ! average CH length
          CORD = DZ/RR                  ! Cos(theta)
          SORD(N,J)=SORD(N,J)+0.5*(3.*CORD**2-1.)
        end do
      end do
      return
      end
*
*======================= ORDEROUT ====================================
*
      subroutine ORDEROUT
      include "tranal.h"
      open(unit=26,file=FORD,status='unknown')
      write(26,*)' Order parameter calculations'
      write(26,*)'  Bond                 order       length   ',
     &'  DC(1/A**3)'
      FAC=NDUP*1./IAN
*      do J=1,NEQH
      J=0
 10   J=J+1
        ITYP=ITS(NC(J))
        NML=NSPEC(ITYP)
*  checking 3 in line
        if(J.le.NEQH-2)then
          if(NC(J).eq.NC(J+1).and.NC(J).eq.NC(J+2))then
            SO=0.
            SON=0.
            SOA=0.
            do N=1,NML
              S1=SORD(N,J)*FAC
              S2=SORD(N,J+1)*FAC
              S3=SORD(N,J+2)*FAC
              if(S1.gt.S2.and.S2.gt.S3)then
                SO=SO+S3
                SON=SON+S2
                SOA=SOA+S1
              else if(S1.gt.S3.and.S3.gt.S2)then
                SO=SO+S2
                SON=SON+S3
                SOA=SOA+S1
              else if(S2.gt.S1.and.S1.gt.S3)then
                SO=SO+S3
                SON=SON+S1
                SOA=SOA+S2
              else if(S2.gt.S3.and.S3.gt.S1)then
                SO=SO+S1
                SON=SON+S3
                SOA=SOA+S2
              else if(S3.gt.S1.and.S1.gt.S2)then
                SO=SO+S2
                SON=SON+S1
                SOA=SOA+S3
              else 
                SO=SO+S1
                SON=SON+S2
                SOA=SOA+S3
              end if
            end do
            BL=(CSHL(J)+CSHL(J+1)+CSHL(J+2))*FAC/(3.*NML)
            DC=SO/BL**3
            DCN=SON/BL**3
            DCA=SOA/BL**3
        write(26,'(a4,a1,a4,2i5,3f12.4,a)')
     +  NM(NC(J)),'-',NM(NH(J)),NC(J),NH(J),SO,BL,DC,'       3'
            J=J+1
        write(26,'(a4,a1,a4,2i5,3f12.4,a)')
     +  NM(NC(J)),'-',NM(NH(J)),NC(J),NH(J),SON,BL,DCN,'      3'
            J=J+1
        write(26,'(a4,a1,a4,2i5,3f12.4,a)')
     +  NM(NC(J)),'-',NM(NH(J)),NC(J),NH(J),SOA,BL,DCA,'      3'
            if(J.lt.NEQH)then
              go to 10
            else
              return
            end if
          end if
        end if
*  checking 2 in line
        if(J.le.NEQH-1)then
          if(NC(J).eq.NC(J+1))then
            SO=0.
            SON=0.
            do N=1,NML
              S1=SORD(N,J)*FAC
              S2=SORD(N,J+1)*FAC
              if(S1.gt.S2)then
                SO=SO+S2
                SON=SON+S1
              else
                SO=SO+S1
                SON=SON+S2
              end if
            end do
            SO=SO/NML
            SON=SON/NML
            BL=(CSHL(J)+CSHL(J+1))*0.5*FAC/NML
            DC=SO/BL**3
            DCN=SON/BL**3
        write(26,'(a4,a1,a4,2i5,3f12.4,a)')
     +  NM(NC(J)),'-',NM(NH(J)),NC(J),NH(J),SO,BL,DC,'    2'
            J=J+1
        write(26,'(a4,a1,a4,2i5,3f12.4,a)')
     +  NM(NC(J)),'-',NM(NH(J)),NC(J),NH(J),SON,BL,DCN,'    2'
            if(J.lt.NEQH)then
              go to 10
            else
              return
            end if
          end if
        end if
        SO=0.
        BL=0.
        do N=1,NML
          SO=SO+SORD(N,J)*FAC
        end do
        SO=SO/NML
        BL=CSHL(J)*FAC/NML
        DC=SO/BL**3
        write(26,'(a4,a1,a4,2i5,3f12.4)')
     +  NM(NC(J)),'-',NM(NH(J)),NC(J),NH(J),SO,BL,DC
        if(J.lt.NEQH)go to 10
      return
      end


