 	program TRANAL
*  Analys of trajectory file 
*  Calculations of orientational correlation functions 
*  three-body correlations and many other things
*
*  v 3.1    2005-04-22   Odred parameter /dipole coupling calculations
*  v.3.0    2005-02-10
*
	include "tranal.h"
        parameter (MAXFIL=1000)
	character*64 filnam(MAXFIL),fildif,filres,fildif2,
     +filtcf,fildfm,FFILTR,filxm,
     +PATHDB,FILPDB,FNAME,FANGL,FTOR,HOST*24,RNAME*96,TMPFIL*8,COM*128,
     +FXMOL,FIRDF,FRMS,CH*4,cdum*8
      character*80 STR,TAKESTR,FSET
	dimension TIMIN(MAXFIL) 
	dimension OX(NTOT),OY(NTOT),OZ(NTOT)
	real*4 TX(NTOT),TY(NTOT),TZ(NTOT)
	logical logo,LORIENT,LCOR3,LDIFF,LRES,LPDB,LANG,
     +LRDF,LRMS,LTCF,LVEL,LFILTR,LORD
	namelist /INPUT/LCOR3,LORIENT,IS1,IS2,IS3,AMPL,fil3cor,filori
     +,RMAXX,NRX,RMAXY,NRY,ITH,ISOR,ROMAX,NOM,NOI,IO1,IO2,IO3,NFORM,
     +RB12,D12,IPRINT,NDUP,FSET,NOMX,NOMY,NOMZ,RXMAX,RYMAX,RZMAX,
     +ZB,DZB,IPROC,LDIFF,IDF,MTR,DTT,NTT,ISTEP,FILDIF,FILRES,ICNT,
     +LRES,IR1,IR2,RRN,RRX,RRD,NITT,TIMM,TTER,LCOL2,NDUR,NM,IDFM1,IDFM2,
     +LANG,FANGL,FTOR,NAA,LXMOL,FXMOL,RDFCUT,NA,NR1,NR2,LRDF,FIRDF,
     +FORDF,LPDB,PATHDB,NAMOL,NFBEG,NFEND,FNAME,FCRD,LORD,NEQH,
     +NH,NC,FORD,
     +LRMS,FRMS,IMAC,BOXL,BOYL,BOZL,NTYPES,NSPEC,IAT,ISELF,
     +LTCF,filtcf,N1,N2,ITCF,NSTEG,DTCF,LVEL,NAI,RMI,RMAX,
     +RB13,D13,RB23,D23,LFILTR,FFILTR,NUMTR,BREAKM
*  
*
*    Required parameters:
*
*    NFORM - trajectory format
*        MDYN     - binary MDynaMix
*        XMOL     - XMOL  (xyz)
*        PDBT     - PDB trajectory from GROMACS
*
*  LRDF - calculate many RDF-s
*    FIRDF - input file specifying rdf (the same type as in MDynamix)
*    FORDF - resulting rdfs
*    RDFCUT - RDF cutoff
*    NA    - RDF resolution
*    NAI   - RDF resolution for intramolek RDF
*    RMI,RMAX - min and max limits of intramolec RDF
*     
*  LORIENT - calculate orientational or spatial distribution functions
*    Recuired parameters:
*    NOI - number of equivalent local coord. systems 
*    IO1, IO2, IO3 (NOI) - define local coordinate system
*    IPROC = -1 only for DNA - SDF around two base pairs
*               IO1 = phosphates; IO2 - which counts; IO3 - which are
*               used to build average structure     
*             0 normal calculations of SDF defined by IO1,IO2,IO3
*             1,2,3  - slices SDF in 3 planes. may not work properly
*             4 only for DNA fragment : SDF around DNA as a whole
*               in this case DNA strands should be 1 and 2 type  
*    
*    FSET - file with atom numbers for calculation of average structure 
*
*  LDIFF - calculate diffusion
*    DTT - total time in s	
*    IAT - atom num. in the molecule for diffusion
*    ISTEP - interval
*    BREAKM (ps) - max break of trajectory 
*
*  LCOR3 - three-body correlations
*    IS1(NDUP),IS2(NDUP),IS3(NDUP) - site number
*    RMAXX, RMAXY - size of the output field
*    NRX,   NRY   - resolution
*    RB12  - fixed distance between 1 and 2
*    D12   - fluctuation of RB12
*
*  LANG - calculate distribution over torsion angles
*    Required parameters:
*    FANGL - name with atom numbers defining torsions
*    FTOR  - output file
*
*  LTCF - calculate tcf
*    N1(ITYP),N2(ITYP) - define vector on eachh molecule for reorient.tcf
*    ITCF(12) - which tcf calculate
*    NSTEG - num of steps for tcf
*    DTCF - time step of TCF
*
*  LORD - calculate order parameter / dipole couplings relative Z axis
*
*    NEQH - number of "H" atoms for given C 
*    NC   - site number of C atom
*    NH   - sites of "H" atoms 
*    FORD - file name containing output
*
*  LRMS - root mean square deviation
*    FRMS - file for RMS
*    IMAC - for which molecule types calculate RMS (relative to .mol file) 
*    NMRMS - which molecule test for RMS (if 0 - all molecules of this type)
*    FILREF - filename with reference structure ( "XMOL" format)
*
*  other things:
*
*   LVEL - read velocities from the trajectory files
*   LFILTR - analysis for particular atoms
*   FFILTR - which atoms take for  the analysis
*   NUMTR - number of atoms in the trajectory
*
*  LXMOL - write trajectory in XMOL format
*    Required parameters:
*    FXMOL - name of files
*    ISTEP - how often dump comfigurations in rewrited trajectory
*
*  default values
	NFORM='XMOL'
	NDUP=1  
	NDUR=1
        ISTEP=1
	IAT=1
	NTT=200
	MTR=MTRM
	RRD=0.25
	RDFCUT=10.
	NA=100
	IS3(1)=1       
	IPRINT=5
	IPROC=0                     
	BREAKM=5.
	LORIENT=.false.
	LRDF=.false.
	LRES=.false.
	LPDB=.false.
	LANG=.false.
	LTCF=.false.
	LDIFF=.false.
	LFILTR=.false.
	LXMOL=.false.
	LVEL=.false.
	do I=1,MAXCOLOR
	  AMPL(I)=0.2*I
	end do
	NRX=NMX
	NRY=NMY
	ITH=1
	ISOR(1)=1
	ROMAX=5.
	NOM=50
	NOMX=50
	NOMY=50
	NOMZ=50
	ZB=0.
	DZB=0.1 
	NAA=36
	ICTCF=0
	fil3cor='correl3.ps'
	filori='orient.ps'
	fildif='tcor.dat' 
        filres='restime.lst' 
	fcrd='mean.crd'
	filpdb='fort.7' 
	ftor='tordist.lst'
	fxmol='fxmol.lst'
	frms='frms.dat'
* Data input
	J=0             
	NTP=0 
	IADT(1)=0   
	read(*,INPUT)                              
	NF=NFEND-NFBEG+1       
	if(NFORM.eq.'PDBT')LVEL=.false.
* Parameters for analysis of dihedrals  
	if(LANG)then
	  open(unit=17,file=FANGL,status='old',err=199)
	  IE=0 
	  STR=TAKESTR(17,IE)
	  read(STR,*)NAG               ! num. of types 
	  if(NAG.gt.NTOR)stop ' increase NTT'
	  if(NA.gt.NAAM)stop ' increase NAAM'
	  STR=TAKESTR(17,IE)
	  read(STR,*)(MANGL(I),I=1,NAG)    ! torsions of each type
	  IADT(1)=0
	  do I=1,NAG
	    IADT(I+1)=IADT(I)+MANGL(I)
	  end do
	  NADT=IADT(NAG+1)                   ! total  
	  if(NADT.gt.NT)stop 'increase NT'
	  do I=1,NADT                   
	    STR=TAKESTR(17,IE)
  	    READ(STR,*)IT(I),JT(I),KT(I),LT(I)    ! which
	  end do
	  close(17)
	end if
	NCF=0
	if(LORIENT.and.(IPROC.le.0.or.IPROC.ge.4))then
*   coordinates of which sites will be averaged in local coord.system
	   write(*,*)NOMZ,NOMY,NOMX
	   write(*,'(6e13.5)')RXMAX,RYMAX,RZMAX
	   do II=1,NOI
	     if(IO3(II).gt.0)then
		NCF=NCF+1
		ICF(II)=NCF
	     end if
	   end do
	   write(*,*)NCF,(ICF(I),I=1,NCF)
	   if(NCF.eq.0.and.IPROC.le.0)go to 8
	   open(unit=14,file=FSET,status='old',err=901)
	   read(14,*)NMSTR
	   do I=1,NMSTR
	      read(14,*,err=902,end=902)ISREP(I),(ISM(I,II),II=1,NCF)
	   end do
	   close(14)
	   write(*,*)' read ',NMSTR,' reference atom coordinates'
	   go to 8
 901	   write(*,*)' file ',FSET,' not found'
	   stop
 902	   write(*,*)' input error in file ',FSET,' line ',I
	   stop
	end if
 8	if(LXMOL)then
 	  LLNX=0 
 	  do I=1,64
 	    ISTR=ichar(FXMOL(I:I))
	    if(ISTR.le.15)then
	      LLNX=I-1
	      go to 18
	    end if
            if(FXMOL(I:I).ne.' ')LLNX=I
	  end do 
	end if
*    check array dimensions
 18	if(NAA.gt.NTA)stop ' increase NTA'
	if(NF.le.0)stop '!!! invalid NFBEG,NFEND'  
	if(NFEND.ge.1000)stop '!!! NFEND > 999 not supported' 
	if(NF.gt.MAXFIL)stop '!!! increase MAXFIL !!!'
	if(NOI.gt.NDUPM)stop '!!! increase NDUPM'
	if(NOMX.gt.NOMXM)stop 'increase NOMXM !!!'
	if(NOMY.gt.NOMYM)stop 'increase NOMYM !!!'
	if(NOMZ.gt.NOMZM)stop 'increase NOMZM !!!'
	if(NA.gt.NAAM)stop 'increase NAAM !!!'
	IL=0 
	do I=1,64
	  ISTR=ichar(FNAME(I:I))
	  if(ISTR.le.15)then
	    LF=I-1
	    go to 11
	  end if
        if(FNAME(I:I).ne.' ')IL=I
	end do 
	LF=IL
*  Check and reconstruct file list
*  Check that the file list is on a remote computer
 11	JJ=0
	do I=1,LF-1
	  if(FNAME(I:I).eq.'/')JJ=I
	end do	
 26	LFJ=LF-JJ
	write(*,*)FNAME(1:LF)
	J=0
 	do I=1,NF
	  NFL=NFBEG+I-1
	  filnam(I)(1:LF)=FNAME(1:LF)
	  filnam(I)(LF+1:LF+4)='.000'
	  do M=LF+5,64
	    filnam(I)(M:M)=' '
	  end do
	  if(NFL.lt.10)then
	    write(filnam(I)(LF+4:LF+4),'(i1)')NFL
	  else if(NFL.lt.100)then
	    write(filnam(I)(LF+3:LF+4),'(i2)')NFL
	  else
	    write(filnam(I)(LF+2:LF+4),'(i3)')NFL
	  end if 
	  write(*,*)' looking for file ',filnam(I)(1:40)
	  if(NFORM.eq.'PDBT')then
            open (unit=12,file=filnam(I),status='old',err=5)
*	if(IPRINT.ge.5)write(*,*)' file ',filnam(I),' is open'
 9	    read(12,'(a)',err=10)STR
*     PDB trajectory format
	    if(STR(1:6).ne.'HEADER')go to 9
	    do K=7,80
	      if(STR(K:K+1).eq.'t=')then
	        read(str(K+2:K+20),*)FULTIM
  	        if(IPRINT.ge.5)write(*,*)' FULTIM ',FULTIM,' ps' 
		go to 13
	      end if
	    end do
	    write(*,*)' time is not defined '
 13	    continue
	    go to 20 
*  XMOL trajectory format
	  else if(NFORM.eq.'XMOL')then
            open (unit=12,file=filnam(I),status='old',err=5)
*	if(IPRINT.ge.5)write(*,*)' file ',filnam(I),' is open'
	    read(12,*,err=10)NSTOT
	    read(12,*,err=10)cdum,FULTIM
	    FULTIM=0.001*FULTIM            ! in ps
	    if(IPRINT.ge.5)write(*,*)' FULTIM ',FULTIM,' ps'  
 	    go to 20 
*  Binary MDynaMix format
	  else if(NFORM.eq.'MDYN')then
            open (unit=12,file=filnam(I),status='old',
     +    form='unformatted',err=5)
	    if(IPRINT.ge.5)write(*,*)' file ',filnam(I),' is open'
            read(12,err=10) IA, dt, boxl, boyl, bozl, unitl, ntypes
	    if(IA.eq.1)LVEL=.true.
	    if(IPRINT.ge.5)write(*,*)' num.of types ',NTYPES  
	    if(I.gt.1)then
	      if(NTP.ne.NTYPES)then
	        write(*,*)
     +      ' uncompatible NTYPES in ',filnam(I),' and ',filnam(I-1) 
	        stop
	      end if
	    else
	      rewind (12)
              read(12,err=10) IA, dt, boxl, boyl, bozl, unitl, ntypes,
     x                (nspec(ii),nsits(ii),logo,ii=1,ntypes)
	    end if 
	    NTP=NTYPES  
	    do ITYP=1,NTYPES
	      read(12,err=10)
	      if(IPRINT.ge.8)write(*,*)ITYP,NSPEC(ITYP),NSITS(ITYP)
	    end do
	    read(12)IA,FULTIM
	    FULTIM=FULTIM*1.d12         ! in ps
	    if(IPRINT.ge.5)write(*,*)' FULTIM ',FULTIM,' ps'  
	    close(12)
	    go to 20 
	  else
	    write(*,*)' Unsupported trajectory format ',NFORM
	    stop
	  end if
  5	  write(*,*)' File not found: ',filnam(I)
	  go to 20
 10	  write(*,*)' File ',filnam(I),': input error'
 20	  close(12)
	  J=J+1
	  TIMIN(J)=FULTIM 
	  filnam(J)=filnam(I)
	end do
      write(*,*)' input of the file list is completed'	  
 30	NF=J
	FULTIM0=TIMIN(1)
 	TTER=TTER*1.d-12    
	if(LORIENT)then
	  if(NOMAX.gt.NMX)stop 'too large NOMAX'
	  if(NOMAX.gt.NMY)stop 'too large NOMAX'
	  if(NOM.gt.NOMAX)stop 'increase NOMAX' 
	  if(IPROC.eq.0.and.2*NOM.gt.NOMAX)stop 'increase NOMAX'
	end if 
	if(LDIFF)then
	  if(MTR.gt.MTRM)stop ' increase MTRM'
	  if(NTT.gt.NTCD)stop ' increase NTCD'
	  do ITYP=1,NTT
	    RCUM(ITYP)=0.d0
	    NCUM(ITYP)=0
	  end do   
	  do I=1,MAXMOL
	    ISHX(I)=0
	    ISHY(I)=0
	    ISHZ(I)=0
	  end do
	end if 
	if(LRES)then  
	  if(NITT.gt.NITTM)stop 'increase NITTM'
	  if(RRN.gt.RRX)stop 'RRN>RRX'
	  RRNN=RRN-RRD
	  RRNX=RRN+RRD
	  RRXN=RRX-RRD
	  RRXX=RRX+RRD
	end if
	if(LRMS)then
	   open(unit=24,file=frms,status='unknown')
	end if
	if(NRX.gt.NMX)stop ' increase NMX' 
	if(NRY.gt.NMY)stop ' increase NMY'
*  for 2D distributions 
	RMX12=(RB12+0.5*D12)**2
	RMN12=(RB12-0.5*D12)**2 
	DXX=2.d0*RMAXX/NRX
	DYY=2.d0*RMAXY/NRY
	DRI=RMAX-RMI
*  for 3D distributions
	DDX=2.d0*RXMAX/NOMX
	DDY=2.d0*RYMAX/NOMY
	DDZ=2.d0*RZMAX/NOMZ
	ROMAX2=(RXMAX**2+RYMAX**2+RZMAX**2)
	DDO=ROMAX/NOM     
	RDF2X=(RDIF2+DDIF2)**2
	RDF2N=(RDIF2-DDIF2)**2	
*  Input other parameters
*  Adresses and referenses
	IAN=0 
	ISADR(1)=0
	ISADDR(1)=0    
	IADDR(1)=0
	NOP=0 
	NSITES=0
	NSTOT=0 
	FNSTR=0.
	IATOM=0
	IMOL=0
	IST=0   
	NCOR=0    
	JBREAK=1                      
	NOM2=2*NOM
	RMSS = 0.
	TRTEMP=0.
	NX=0
	do ITYP=1,NTYPES
	  LIST(ITYP)=1
	  if(NFORM.eq.'MDYN')NSTS=NSITS(ITYP)
          CALL READMOL (SUMM,NX,ITYP,PATHDB,
     +  NAMOL(ITYP))
	  if(NFORM.eq.'MDYN'.and.NSTS.ne.NSITS(ITYP))then
	    write(*,*)' Molecule of type ',ITYP,' has ',NSTS,
     &' sites in the trajectory but ',NSITS(ITYP),' in the input file'
	    stop
	  end if
          TOTMAS       = TOTMAS+SUMM*NSPEC(ITYP)
          SUMMAS(ITYP) = SUMM 
	  NAME(ITYP)=NAMOL(ITYP)(1:6)
        end do                
        FACTM=AVCNO*1.d3
        do ityp=1, ntypes
	  ISADR(ITYP+1)  = ISADR(ITYP)+ NSITS(ITYP)          ! site addr
	  ISADDR(ITYP+1) = ISADDR(ITYP)+NSPEC(ITYP)*NSITS(ITYP)  ! atom adr
          IADDR (ITYP+1) = IADDR (ITYP)+NSPEC(ITYP)         ! mol. addr
          NOP     = NOP    + NSPEC(ITYP)
          NSITES  = NSITES + NSITS(ITYP)
          if(NSITS(ITYP).eq.2)FNSTR=FNSTR+2.d0*NSPEC(ITYP)
          if(NSITS(ITYP).ge.3)FNSTR=FNSTR+3.d0*NSPEC(ITYP)
          NSTOT   = NSTOT  + NSPEC(ITYP)*NSITS(ITYP)
          FNSS3   = 3.D0*DFLOAT(NSITES)
          write(*,'(a6,i4,3x,a5,i5,4x,a6,i4)')
     +' type ',ITYP,' Nmol',NSPEC(ITYP),
     +'Nsites',NSITS(ITYP)
	  do J=ISADR(ITYP)+1,ISADR(ITYP+1)
	    MASSD(J)=MASS(J)/TOTMAS/FACTM
	    ITS(J)=ITYP
	  end do                     !    Nsite -> type
	  do IS=1,NSPEC(ITYP)
	    IMOL=IMOL+1
            do I=1,NSITS(ITYP)
	      ISITE=ISADR(ITYP)+I
	      IATOM=IATOM+1
	      NNUM(IATOM)=IMOL        !   Natom -> Nmol
	      NSITE(IATOM)=ISITE      !   Natom -> Nsite
	      ITYPE(IATOM)=ITYP       !   Natom -> type
	      if(IPRINT.ge.9)write(*,'(4I6,2x,2a4,a6)')
     +        IATOM,IMOL,ISITE,ITYP,NM(ISITE)
	    end do
	  end do
        end do                   
* Renumeration array
	if(LFILTR)then
	   do I=1,NUMTR
	     NUMR(I)=0
	   end do
	   write(*,*)' renumerating atoms from file ',FFILTR
	   open(unit=14,file=FFILTR,status='old')
	   do I=1,NSTOT
	      read(14,*,err=921,end=921)II,NUMO(II)
	      NUMR(NUMO(II))=II
	      if(IPRINT.ge.7)write(*,*)I,II,NUMO(II)
	   end do
	   close(14)
	else
	   NUMTR=NSTOT
	   do I=1,NSTOT
	      NUMO(I)=I
	      NUMR(I)=I
	   end do	   
	end if
*   Input RDFs
	if(LRDF)then
	  open(unit=17,file=FIRDF,status='old',err=197)
	  IE=0
	  N=0
	  STR=TAKESTR(17,IE)
	  read(STR,*)NRDF
	  write(*,*)' Number of RDF-s: ',NRDF
	  if(NRDF.gt.MAXRDF)stop 'Increase MAXRDF!!!'
          DO K       = 1,NRDF
 	    IE=-1
	    STR=TAKESTR(17,IE)
	    if(str(1:1).eq.'&')then
              READ(str(2:24),*)IRP
	      if(IRP.gt.MAXGR) stop 'Increase MAXGR!!!'
	      IREP(K)=IRP
	      do IR=1,IRP
	        STR=TAKESTR(17,IE)
	        read(STR,*,err=99)I,J  
		IRD(K,IR)=I
		JRD(K,IR)=J
	      end do
	    else 
	      IREP(K)=1
	      read(STR,*,err=99)I,J  
	      IRD(K,1)=I
	      JRD(K,1)=J
	    end if
	    write(*,*)' RDF  No ',K,' equiv ',IREP(K)
	    do I=1,IREP(K)
	      write(*,'(2I6,2(3x,a4))')
     +        IRD(K,I),JRD(K,I),NM(IRD(K,I)),NM(JRD(K,I))
	    end do
          END DO
	  go to 101
 99	  write(*,*)' input error in file ',FIRDF
	  stop
 101	  continue
	end if
*  Compose list of atoms for calculation of residence time
	if(LRES)then
	   NRT1=0
	   NRT2=0
	   IHP=0
	   do I=1,NR1
	      IS=IR1(I)
	      ITYP1=ITS(IS)
	      NS1=NSPEC(ITYP1)
	      do J=1,NS1
		 NRT1=NRT1+1
		 if(NRT1.gt.NRT1M)stop ' increase IRT1M'
		 ISP=ISADDR(ITYP1)+(J-1)*NSITS(ITYP1)+IS-ISADR(ITYP1)
		 IRS1(NRT1)=ISP
	      end do
	   end do
	   do I=1,NR2
	      IS=IR2(I)
	      ITYP2=ITS(IS)
	      NS2=NSPEC(ITYP2)
	      do J=1,NS2
		 NRT2=NRT2+1
		 if(NRT2.gt.NRT2M)stop ' increase IRT2M'
		 ISP=ISADDR(ITYP2)+(J-1)*NSITS(ITYP2)+IS-ISADR(ITYP2)
		 IRS2(NRT2)=ISP
	      end do
	   end do
	   if(IPRINT.ge.8)write(*,*)NRT1,(IRS1(I),I=1,NRT1)
	   if(IPRINT.ge.8)write(*,*)NRT2,(IRS2(I),I=1,NRT2)
	end if	
* check list of torsions
	if(IPRINT.ge.6.and.LANG)then 
	  write(*,*)' distribution over torsion angles:'
	  do I=1,NAG
          write(*,*)I,' type'  
	    do J=IADT(I)+1,IADT(I+1)  
	      write(*,*)NM(NSITE(IT(J))),NM(NSITE(JT(J))),
     + NM(NSITE(KT(J))),NM(NSITE(LT(J)))
	    end do
	  end do               
	end if
	if(NFORM.eq.'XMOL')then
	  HBOXL=0.5*BOXL
	  HBOYL=0.5*BOYL
	  HBOZL=0.5*BOZL
	  VOL=BOXL*BOYL*BOZL 
	end if
*  Zero tables
	do I=1,NA
	  RDF(I)=0.
	end do
	do IX=0,NRX
	  do IY=0,NRY
	    P3COR(IX,IY)=0.d0
	    P3CO2(IX,IY)=0.d0
	  end do
	end do
	do IX=0,2*NOM
	  do IY=0,NOM
	    POR(IX,IY)=0.
	  end do
	end do
	do I=1,NAG
	  do J=1,NAA
	    NPOP(I,J)=0 
	  end do
	end do 
	do IX=0,NOMXM
	   do IY=0,NOMYM
	      do IZ=0,NOMZM
		 ID3(IX,IY,IZ)=0
	      end do
	   end do
	end do
	do I=1,NS
	   XAV(I)=0.
	   YAV(I)=0.
	   ZAV(I)=0.
	   XAV2(I)=0.
	   YAV2(I)=0.
	   ZAV2(I)=0.
	   IAA(I)=0
	end do
	ITIR=0
	ITIR1=0
	ITIR2=0
	TIMRS=0
	TIMRS1=0.
	TIMRS2=0.    
	IPDB=6
	COR2=0.d0
	COR22=0.d0                 
	FULTIM1=TIMIN(1)
	write(*,*)' FULTIM1=',FULTIM1
	if(LDIFF)write(*,*)
     +' Calculation of the diffusion coefficients for type ',IDF,
     + NSPEC(IDF),NSITS(IDF)
*  Initialize TCF
	if(LTCF)call TCFINP
*  Initialize order parameter calculations
	if(LORD)call ORDERIN
*  Put other initialization things here:
*
*  Begin reading of next trajectiry file 
	ITRI=0
	do IFL=1,NF        
	  IIN=0     ! Signals that we read headers
*  Reading HEADERs
*  Case of PDB trajactory
 35	  if(NFORM.eq.'PDBT')then
	    if(IIN.eq.0)then
              open (unit=12,file=filnam(IFL),status='old',
     +        form='formatted') 
	      if(IPRINT.ge.7)write(*,*)' file ',IFL,' open'
	    end if
 31	    read(12,'(a)',end=45) STR
	    if(STR(1:6).ne.'HEADER')go to 31 
	    do K=7,80
	      if(STR(K:K+1).eq.'t=')then
	        read(str(K+2:K+20),*)FULTIM
		go to 33
	      end if
	    end do
	    write(*,*)' time is not defined '
 33	    continue
* Line 2 
 32	    read( 12,'(a)',end=45 ) STR
	    if(STR(1:4).ne.'CRYS')go to 32
	    read(str,*)cdum,BOXL,BOYL,BOZL
  	    HBOXL=0.5*BOXL
	    HBOYL=0.5*BOYL
	    HBOZL=0.5*BOZL
	    VOL=BOXL*BOYL*BOZL 
	    if(IPRINT.ge.6)write(*,'(a,3f12.3)')
     &      ' Box: ',BOXL,BOYL,BOZL
	  else if(NFORM.eq.'XMOL')then
*  XMOL trajectory
	    if(IIN.eq.0)then
              open (unit=12,file=filnam(IFL),status='old',
     +    form='formatted') 
	      if(IPRINT.ge.7)write(*,*)' file ',IFL,' open'
	    end if
 	    read(12,*,err=40,end=45) NUMTR
            read( 12,*,err=40,end=40 ) cdum,FULTIM
	    FULTIM=0.001*FULTIM           ! in ps
	  else
*  Binary MDynamix trajectory
	    if(IIN.eq.0)then
              open (unit=12,file=filnam(IFL),status='old',
     +        form='unformatted') 
              read(12) IVEL, dt, boxl, boyl, bozl, unitl, ntypes,
     x                (nspec(i),nsits(i),logo,i=1,ntypes)
	      if(LXMOL)then
	        filxm(1:LLNX)=FXMOL(1:LLNX)
	        filxm(LLNX+1:LLNX+4)=filnam(IFL)(LF+1:LF+4)
	        open(unit=19,file=filxm,status='unknown')
	      end if
	      if(IPRINT.ge.7)write(*,*)
     &          'read first line.',NTYPES,' types'
              do ityp=1, ntypes
                NSB = ISADR (ITYP)+1
                NSE = ISADR (ITYP+1)
* Lines from 2 to NTYPES+1
                read( 12 ) (mass(j), j=NSB,NSE),LIST(ITYP)
		if(IPRINT.ge.8)write(*,*)ityp,NSB,NSE,LIST(ITYP)
              end do                    
	      if(IPRINT.ge.7)write(*,*)' read masses   '
	    end if
* First line of a configureation
            read(12,err=40,end=45)IA,fultim,cumtim,
     &      TEMP,PRES,EP,BOXL,BOYL,BOZL,(LIST(LL),LL=1,NTYPES)
  	    HBOXL=0.5*BOXL
	    HBOYL=0.5*BOYL
	    HBOZL=0.5*BOZL
	    VOL=BOXL*BOYL*BOZL
	    FULTIM=FULTIM*1.d12                 ! in ps
	    if(IPRINT.ge.6)write(*,'(2(a,3f10.2))')
     &      'Box: ',BOXL,BOYL,BOZL,' term:',TEMP,PRES,EP
	  end if
	  if(IIN.eq.0)then
 	    write(*,'(2a/a,f14.3,a8,6I3)')
     +  ' begin analys of file  ',filnam(IFL), 
     +  ' init. T = ',fultim
	    IIN=1
	  end if  
	  IBREAK=0
	  DIFT=FULTIM-FULTIM1
	  if(DIFT.gt.BREAKM)then
	    write(*,*)
     +    'break in trajectory file. from ',FULTIM1,' to ',
     +    FULTIM,'ps'
	    IBREAK=1
	  end if    
	  if(IPRINT.ge.5.and.(LCOR3.or.LORIENT))
     +    write(*,'(a,f10.3,3x,a,f12.0,I12)')
     +    ' time=',fultim,' N conf.',COR2,NCOR
	  if(IFL.lt.NF.and.fultim.ge.TIMIN(IFL+1))go to 45
	  FULTIM1=FULTIM 
	  if(IPRINT.ge.7)write(*,*)' proceeding time ',FULTIM
	  if(NFORM.eq.'MDYN')then
c - for each type
            do ityp=1,ntypes
              NSB          = ISADDR(ITYP)+1
              NSE         = ISADDR(ITYP+1) 
* Other NTYPES lines of each point
              if(LIST(ITYP).ne.0)then
	        if(IVEL.le.0)then
	          read(12,err=40,end=45) (TX(j),j=NSB,NSE),
     *                (TY(j),j=NSB,NSE),
     *                (TZ(j),j=NSB,NSE)           
 	          do J=NSB,NSE
	            SX(J)=TX(J)
	            SY(J)=TY(J)
	            SZ(J)=TZ(J)
	          end do
	        else    !  IVEL=1
	          read(12,err=40,end=45) (TX(j),j=NSB,NSE),
     *                (TY(j),j=NSB,NSE),
     *                (TZ(j),j=NSB,NSE)
 	          do J=NSB,NSE
	            SX(J)=TX(J)
	            SY(J)=TY(J)
	            SZ(J)=TZ(J)
	           end do
	           read(12,err=40,end=45) (TX(j),j=NSB,NSE),
     *                (TY(j),j=NSB,NSE),
     *                (TZ(j),j=NSB,NSE)
 	           do J=NSB,NSE
	             VX(J)=TX(J)
	             VY(J)=TY(J)
	             VZ(J)=TZ(J)
	           end do
	         end if    !  IVEL
	       end if     ! LIST
             end do    !  ITYP
	  else     ! ASCII trajectories
            do i=1,NUMTR
	      OX(I)=SX(I)
	      OY(I)=SY(I)
	      OZ(I)=SZ(I)
	      IN=NUMR(I)
	      if(LVEL)then
	        read(12,*,err=40,end=40)CH,XX,YY,ZZ,VVX,VVY,VVZ
		if(IN.ne.0)then
		   SX(IN)=XX
		   SY(IN)=YY
		   SZ(IN)=ZZ
		   VX(IN)=VVX
		   VY(IN)=VVY
		   VZ(IN)=VVZ
		   if(IPRINT.ge.8)write(*,'(2i5,3f10.4)')IN,I,XX,YY,ZZ
		end if
              else
		if(NFORM.eq.'PDBT')then
 53		  read(12,'(a)',end=40)STR
		  if(STR(1:6).eq.'ENDMDL'.or.STR(1:6).eq.'HEADER')then
		    write(*,*)' Number of atoms in the trajectory ',II,
     &		    ' < than in the input file ',NSTOT
		    stop
		  end if
		  if(STR(1:4).ne.'ATOM')go to 53
		  read(str,*,err=40)cdum,II,CH,cdum
		  read(str(31:80),*)XX,YY,ZZ
		else
	          read(12,*,err=40,end=40)CH,XX,YY,ZZ
		end if		
		if(IN.ne.0)then
		   SX(IN)=XX
		   SY(IN)=YY
		   SZ(IN)=ZZ
		   if(IPRINT.ge.8)write(*,'(2i5,3f10.4)')IN,I,XX,YY,ZZ
		end if
	      end if
	  end do
	end if
	JBREAK=0
	if(ITRI.ne.0.and.DIFT.le.0.00001)then
	   write(*,*)' double point in the trajectory file at ',FULTIM
	   go to 35
	end if
	ITRI=1
	DT=DIFT
	if(DIFT.le.0.0001)DIFT=0.0001
	EKIN=0.
	do I=1,NSTOT
	  DX=SX(I)-OX(I)
	  DY=SY(I)-OY(I)
	  DZ=SZ(I)-OZ(I)
 	  if(DX.gt.HBOXL)DX=DX-BOXL
 	  if(DX.lt.-HBOXL)DX=DX+BOXL
 	  if(DY.gt.HBOYL)DY=DY-BOZL
 	  if(DY.lt.-HBOYL)DY=DY+BOZL
 	  if(DZ.gt.HBOZL)DZ=DZ-BOZL
 	  if(DZ.lt.-HBOZL)DZ=DZ+BOZL
	  IS=NSITE(I)
	  if(.not.LVEL)then
	    VX(I)=DX/DIFT
	    VY(I)=DY/DIFT
	    VZ(I)=DZ/DIFT
	  end if
	  EKIN=EKIN+MASS(IS)*(VX(I)**2+VY(I)**2+VZ(I)**2)   ! 2 Ekin
	  OX(I)=SX(I)
	  OY(I)=SY(I)
	  OZ(I)=SZ(I)
	end do
	TEMP=EKIN/(0.3*AVSNO*NSTOT*BOLTZ)
*
*  At this point, arrays SX,SY,SZ contains current coordinates of atoms
*                        VX,VY,VZ - their velocities
*
*  Calculations of different properties begin
*
	  if(LCOR3)then
	    do IGR=1,NDUP   
	      if(IGR.le.NDUR)then
	        call COR3(IGR,1)
	      else
		call COR3(IGR,2)
	      end if
	    end do
	  end if
	  if(LORIENT)then
	    do IGR=1,NDUP
	      call ORIENT(IGR)
	    end do
	  end if   
	  if(LANG)then
	    call  TAKETOR
	  end if     
	  if(mod(IAN/NDUP,ISTEP).eq.0.and.LDIFF)then
	    call DIFFUS
	  end if             
	  if(LPDB.and.mod(IAN/NDUP,ISTEP).eq.0)then
	    IPDB=IPDB+1
	    call PDBDUMP(IPDB)
	  end if
	  if(LRES)then
	    call RESTIM(0)
	  end if
	  if(LRDF)then
	     call RDFCALC
	  end if
	  if(LTCF.and.(FULTIM-FULTIM0)+1.d-6.ge.DTCF*ICTCF)then
 237	     ICTCF=ICTCF+1
	     call GETCOM
	     call DIPOLE
	     call GETROT
	     call GETTCF
	     TRTEMP=TRTEMP+TEMP
	     if(IPRINT.ge.6)write(*,'(a,I6,f11.5,3x,f10.2)')
     +  ' tcf: ',ICTCF,FULTIM,TEMP
	     if(FULTIM-FULTIM0.gt.DTCF*ICTCF)then
		write(*,*)' no config. at t= ',DTCF*ICTCF+FULTIM0
		go to 237
	     end if
	     if(IPRINT.ge.8)then
	       write(*,*)' local atom coordinates in principal s'
	       do I=1,NSTOT
		 IMOL=NNUM(I)
		 QX(IMOL)=WX(I)
		 QY(IMOL)=WY(I)
		 QZ(IMOL)=WZ(I)
		 call ROTMAT(QX,QY,QZ,IMOL,1,.TRUE.)
             write(*,'(2I5,3f10.4)')I,IMOL,QX(IMOL),QY(IMOL),QZ(IMOL)
	       end do
	     end if
	  end if
	  if(mod(IAN/NDUP,ISTEP).eq.0.and.LRMS)then
	     call RMSCALC
	  end if
	  if(LORD)then
	     call ORDERP
	  end if
*  Put your extra subroutines here
*
*         call SOMETHING
*
*  Dump trajectory of selected atoms in XMOL format, with ISTEP
	  if(mod(IAN/NDUP,ISTEP).eq.0.and.LXMOL)then
	     NSAT=0.
	     do ITYP=1,NTYPES
	       if(LIST(ITYP).ne.0)NSAT=NSAT+NSITS(ITYP)*NSPEC(ITYP)
	     end do
	     write(19,*)NSAT
	     write(19,*)' after ',FULTIM*1.d3,' fs'
	     do I=1,NSTOT
		ITYP=ITYPE(I)
		IS=NSITE(I)
		if(LIST(ITYP).ne.0)write(19,'(a2,3(1x,f9.4))')
     +          NM(IS)(1:2),SX(I),SY(I),SZ(I)
	     end do
	  end if
	  IAN=IAN+NDUP
	  go to 35
 40	  write(*,*)' input error in file ',filnam(IFL),' T=',FULTIM
 45	  write(*,'(2a/a,f10.3,a,f12.0,i10,2i8)')
     +' finish analys of file ',filnam(IFL), 
     +  ' final T = ',fultim,'      N conf.  ',COR2,NCOR,ITIR,NDP2
	  close(12)
	end do
	write(*,*)' finish analys of the trajectory'
      write(*,*)' total number of configurations ',IAN  
*   Base pair RDF
	if(LCOR3)then  
	  NSS=NSPEC(ITS(IS1(1)))
	  NPAIRS=NSS*NSPEC(ITS(IS2(1)))
	  if(IS1(1).eq.IS2(1))NPAIRS=NSS*(NSS-1)
	  SH12=4*PI*D12*(RB12**2+D12**2/12.d0)
	  RDF2=COR2*VOL/(dfloat(IAN*NPAIRS)*SH12)
	  write(*,'(a,f8.3,a,f9.5)')
     +' 1-2 pair correlation at r=',RB12,' is ',RDF2
	end if
*   Final output
	if(LCOR3)call MCOR3
	if(LORIENT)call MORI
	if(LDIFF)call MDIFF(fildif)
	if(LRDF)call RDFOUT
	if(LORD)call ORDEROUT
	if(LTCF)then
	  TRTEMP=TRTEMP/ICTCF
	  call TCFOUT(filtcf)
	end if
	if(LRES)then
	  call RESTIM(1)
          open(unit=15,file=filres,status='unknown')
	  write(15,*)'#  distribution over time residence '
	  write(15,*)'#  sites ',IR1(1),' and ',IR2(1)
	  write(15,*)'#  between ',RRN,' and ',RRX,' +/- ',RRD 
	  write(15,*)'#  total ',ITIR2,' and ',ITIR,' events'
	  write(15,*)'#  cases of longer T* time ',ITIR1
	  write(15,*)'#  permission time T* = ',TTER*1.d12,' ps '
	  write(15,*)'#  average number of hydrated pairs ',
     +           IHP*1.*NDUP/IAN
	  write(15,*)
	  write(15,*)'#  av. residence time with T* ',
     +          TIMRS2/ITIR2,' ps' 
	  write(15,*)'#  simple average residence time',TIMRS/ITIR,' ps' 
	  write(15,*)'#  exponent decay            ',
     +  TIMRS1/ITIR1-TTER*1.d12,' ps'
	  write(15,*)
	  write(15,*)'#  time(ps)      hits1      P1     DECAY    ',
     +  ' hits2      P2'
	  DTIRS=ITIR2
	  do I=1,NITT  
	    PPP1=DIST2(I)/ITIR2
	    DTIRS=DTIRS-DIST2(I)
	    PFUN=DTIRS/ITIR2          
	    TTT=I*TIMM/NITT                 
	    PPP=DISTT(I)/ITIR          
	    write(15,'(f12.3,2x,f6.0,2f13.8,2x,f6.0,f13.8)')
     +    TTT,DIST2(I),PPP1,PFUN,DISTT(I),PPP
	  end do
	end if  
	if(LANG)then
	  open(unit=17,file=ftor,status='unknown')
	  write(17,'(a)')'# distribution over torsion angles'
	  write(17,'(a1,10x,50(a4,5x))')'#',
     +(NM(NSITE(IT(IADT(I)+1))),I=1,NAG)
	  write(17,'(a1,10x,50(a4,5x))')'#',
     +(NM(NSITE(JT(IADT(I)+1))),I=1,NAG)
	  write(17,'(a1,10x,50(a4,5x))')'#',
     +(NM(NSITE(KT(IADT(I)+1))),I=1,NAG)
	  write(17,'(a1,10x,50(a4,5x))')'#',
     +(NM(NSITE(LT(IADT(I)+1))),I=1,NAG)
	  do M=1,NAA
	    ANG=-180+(M-0.5)*360/NAA 
	    FACT=NAA*NDUP*1.d0/IAN
	write(17,'(f7.1,50f9.4)')ANG,(NPOP(I,M)*FACT/MANGL(I),I=1,NAG)
	  end do
	  close(17)
	end if
	if(LRMS)then
	   write(*,*)' R M S = ',sqrt((RMSS*ISTEP)/(IAN*NDUP))
	   write(24,'(a,f14.5)')'#    R M S = ',
     +     sqrt((RMSS*ISTEP)/(IAN*NDUP))
	end if
	stop
 197	write(*,*)' Input RDF file not found. File ',FIRDF
	stop
 198	write(*,*)' Xmol prototype file not found. File ',FXMOL
	stop
 199	write(*,*)' Torsion list not found. File ',FANGL
	stop
 921	write(*,*)' Error in renumeration array, file ',FFILTR
	stop
	end  
*          
*========================= COR3 ======================================
*
	subroutine COR3(IGR,ICL)
	include 'tranal.h'
*  calculation of 3-body correlations
	IT1=ITS(IS1(IGR))     ! num of type
	IT2=ITS(IS2(IGR))     
	IT3=ITS(IS3(IGR))    
	NBG1=ISADDR(IT1)+IS1(IGR)-ISADR(IT1)
	NEN1=ISADDR(IT1+1)
	NST1=NSITS(IT1) 
	NBG2=ISADDR(IT2)+IS2(IGR)-ISADR(IT2)
	NEN2=ISADDR(IT2+1)
	NST2=NSITS(IT2) 
	NBG3=ISADDR(IT3)+IS3(IGR)-ISADR(IT3)
	NEN3=ISADDR(IT3+1)
	NST3=NSITS(IT3) 
        NB12=(sqrt(RB12)-RMIN12)/DR12+1
	do I=NBG1,NEN1,NST1
	  do J=NBG2,NEN2,NST2
	    DX12=SX(I)-SX(J)
	    DY12=SY(I)-SY(J)
	    DZ12=SZ(I)-SZ(J)
	    call PBC(DX12,DY12,DZ12)
	    R12S=DX12**2+DY12**2+DZ12**2   
	    NR=NA*sqrt(R12S)/RDFCUT+1
	    if(IPRINT.ge.7.and.R12S.lt.RMX12)
     +write(*,*)I,J,sqrt(R12S),NR
	    if(NR.le.NA)RDF(NR)=RDF(NR)+1.
	    if(R12S.gt.RMN12.and.R12S.lt.RMX12)then
*	write(*,'(6I4,3f12.3)')I,J,IT1,IT2,IS1(IGR),IS2(IGR),RMN12,R12S,RMX12
	      R12=sqrt(R12S)
	      COR2=COR2+1.d0                   
	      do K=NBG3,NEN3,NST3
	        if(I.ne.K.and.J.ne.K)then
	          DX13=SX(I)-SX(K)
	          DY13=SY(I)-SY(K)
	          DZ13=SZ(I)-SZ(K)
	          call PBC(DX13,DY13,DZ13)
	          R13=DX13**2+DY13**2+DZ13**2
		  SCP=(DX12*DX13+DY12*DY13+DZ12*DZ13)/R12
		  X3=SCP-0.5d0*R12
		  Y3=dsqrt(R13-SCP**2)
		  IX3=(X3+RMAXX)/DXX
		  IY3=Y3/DYY            
* 	write(*,'(3I5,3f12.4,3I4)')I,J,K,R12,X3,Y3,IX3,IY3,NRX 
		  if(ICL.eq.1)then
	  	  if(IX3.le.NRX.and.IX3.gt.0.and.IY3.le.NRY)
     +            P3COR(IX3,IY3)=P3COR(IX3,IY3)+1.d0
		  else
	  	  if(IX3.le.NRX.and.IX3.gt.0.and.IY3.le.NRY)
     +            P3CO2(IX3,IY3)=P3CO2(IX3,IY3)+1.d0
		  end if 
	  	end if
	      end do
	    end if
	  end do
	end do
	return
	end
*
*============================== ORIENT ==============================
*	                                                               
	subroutine ORIENT(IGR)
	include 'tranal.h'
	dimension RV(3),D1(3),D2(3),E0(3),EX(3),EY(3),EZ(3)
	dimension FR(NS)
	data INIT/0/
	IZY=RZMAX/DDZ
*  This is only for 2-strand-DNA  (1st and 2nd types) 
	if(INIT.eq.0.and.IPROC.eq.4)then
	   INIT=1
	   NREF=0
	   XR0=0.
	   YR0=0.
	   ZR0=0.
	   do ITYP=1,2
	     IBEG=ISADR(ITYP)+1
	     IEND=ISADR(ITYP+1)
C   reference coordinates
	     do IS=IBEG,IEND
	       NREF=NREF+1
	       XR0=XR0+R(IS,1)
	       YR0=YR0+R(IS,2)
	       ZR0=ZR0+R(IS,3)
	     end do
	   end do
	   XR0=XR0/NREF
	   YR0=YR0/NREF
	   ZR0=ZR0/NREF
	   do ITYP=1,2
	     IBEG=ISADR(ITYP)+1
	     IEND=ISADR(ITYP+1)
	     do IS=IBEG,IEND
	       XLOC=R(IS,1)-XR0
	       YLOC=R(IS,2)-YR0
	       RLOC=sqrt(XLOC**2+YLOC**2)
*  define angle between -180 and 180
	       FREF=acos(XLOC/RLOC)
	       if(YLOC.lt.0.)FREF=-FREF
	       FR(IS)=FREF
	     end do 
	   end do
	   write(*,*)' ref. shift ',XR0,YR0,ZR0
	end if
*  Always:
	do IGR=1,NDUP   ! equivalent atoms "to"
	do II=1,NOI   ! equivalent atom groups "from"
	  if(IPROC.ge.5)then
	    ITL1=ITS(IO1(II))
	    ITL2=ITS(IO2(II))
	    ITL3=ITS(IO3(II))
	    do IML1=1,NSPEC(ITL1)
  	      ISHFT1=ISADDR(ITL1)+(IML1-1)*NSITS(ITL1)-ISADR(ITL1)
	      I=ISHFT1+IO1(II)
	      do IML2=1,NSPEC(ITL2)
  	        ISHFT2=ISADDR(ITL2)+(IML2-1)*NSITS(ITL2)-ISADR(ITL2)
	        I1=ISHFT2+IO2(II)
		D1(1)=SX(I1)-SX(I)
		D1(2)=SY(I1)-SY(I)
		D1(3)=SZ(I1)-SZ(I)
		call PBC(D1(1),D1(2),D1(3))
		RR=sqrt(D1(1)**2+D1(2)**2+D1(3)**2)
		if(RR.le.RB12+D12.and.RR.ge.RB12-D12)then 
		   if(IPRINT.ge.7)write(*,*)'find ',IML1,IML2,' at ',RR
		do IML3=1,NSPEC(ITL3)
  	          ISHFT3=ISADDR(ITL3)+(IML3-1)*NSITS(ITL3)-ISADR(ITL3)
	          I2=ISHFT3+IO3(II)
                  D2(1)=SX(I2)-SX(I)
                  D2(2)=SY(I2)-SY(I)
                  D2(3)=SZ(I2)-SZ(I)
	          call PBC(D2(1),D2(2),D2(3))
	  	  RR=sqrt(D2(1)**2+D2(2)**2+D2(3)**2)
		  if(RR.le.RB13+D13.and.RR.ge.RB13-D13)then 
		    XX=SX(I1)-SX(I2)
		    YY=SY(I1)-SY(I2)
		    ZZ=SZ(I1)-SZ(I2)
		    call PBC(XX,YY,ZZ)
		    RR=sqrt(XX**2+YY**2+ZZ**2)
		    if(RR.le.RB23+D23.and.RR.ge.RB23-D23)then
*  here we have selected all three atoms satisfying conditions 
*  COM of mobil coord.syst.
	  E0(1)=SX(I)
	  E0(2)=SY(I)
	  E0(3)=SZ(I)
	  if(IPRINT.ge.6)write(*,*)I,I1,I2,' ',NM(IO1(II)),
     +  NM(IO2(II)),NM(IO3(II))
 	  call VECT(D1,D2,RV) ! normal v. to 123 plane  (Z axis)
	  call NORM(RV,EZ,RN,3)
	  RV(1)=D1(1)+D2(1)                 ! mediana of 213 angle  ( X axis)
	  RV(2)=D1(2)+D2(2)
	  RV(3)=D1(3)+D2(3)
	  call NORM(RV,EX,RN2,3)            !  X axis
	  call VECT(EZ,EX,EY)               !  Y axis
	  IML=IML1
 	  if(IPROC.eq.5)call MEANSTR(II,IML,E0,EX,EY,EZ,IML2,IML3)
 	  JTYP=ITS(ISOR(IGR))
	  NBG=ISADDR(JTYP)+ISOR(IGR)-ISADR(JTYP)
	  NEN=ISADDR(JTYP+1)
	  NST=NSITS(JTYP)
	  do J=NBG,NEN,NST        ! over molecules with given site
*	    if(J.eq.ISHFT1+IO1(II).or.J.eq.ISHFT2+IO2(II).or.
*     +   ISHFT3+J.eq.IO3(II))go to 320
	    if(ISELF.eq.0.and.(NNUM(I1).eq.NNUM(J).or.NNUM(I2).eq.NNUM(J)
     + .or.NNUM(I).eq.NNUM(J)))go to 320
*	    if(J.eq.ISHFT1+IO1(II))go to 320
	    DX=SX(J)-E0(1)
	    DY=SY(J)-E0(2)
	    DZ=SZ(J)-E0(3)
	    call PBC(DX,DY,DZ)
	    RR2=DX**2+DY**2+DZ**2
            NCOR=NCOR+1
*   Calculating 3D distribution
	    if(RR2.lt.ROMAX2)then
	      RR=sqrt(RR2)
              XM=EX(1)*DX+EX(2)*DY+EX(3)*DZ       ! X-coord in molec.c.s. 
              YM=EY(1)*DX+EY(2)*DY+EY(3)*DZ       ! Y-coord in molec.c.s. 
              ZM=EZ(1)*DX+EZ(2)*DY+EZ(3)*DZ       ! Z-coord in molec.c.s.
*  calculate 3D density 
	      NXM=(XM+RXMAX)/DDX
	      NYM=(YM+RYMAX)/DDY
	      NZM=(ZM+RZMAX)/DDZ
	      if(IPROC.eq.5)then
	        if(NXM.ge.0.and.NXM.le.NOMX.and.NYM.ge.0.
     + and.NYM.le.NOMY.and.NZM.ge.0.and.NZM.le.NOMZ)then
     	         ID3(NXM,NYM,NZM)=ID3(NXM,NYM,NZM)+1
		 ICNT3=ICNT3+1
		 if(IPRINT.ge.8)write(*,*)I,J,NXM,NYM,NZM,XM,YM,ZM
		end if
	      else if(IPROC.eq.6.and.abs(abs(ZM)-ZB).le.DZB)then  
* case of Z=ZB plane            
	        NXM=(XM+RXMAX)/DDX
	        NYM=(YM+RYMAX)/DDY
		if(IPRINT.ge.7)write(*,*)I,J,NXM,NYM,NZM,XM,YM,ZM
	if(NXM.ge.0.and.NXM.le.NOMX.and.NYM.ge.0.and.NYM.le.NOMY)then
	   	  NCOR=NCOR+1
     		  POR(NXM,NYM)=POR(NXM,NYM)+1.
		end if
	      end if
	      if(IPROC.eq.7.and.abs(YM-ZB).le.DZB)then   ! Y=ZB plane         
	        NXM=(XM+RXMAX)/DDX
	        NYM=(YM+RYMAX)/DDY
		if(IPRINT.ge.7)write(*,*)I,J,NXM,NYM,NZM,XM,YM,ZM
	if(NXM.ge.0.and.NXM.le.NOMX.and.NYM.ge.0.and.NYM.le.NOMY)then
	   	  NCOR=NCOR+1
     		  POR(NXM,NYM)=POR(NXM,NYM)+1.
		end if
	      end if
	      if(IPROC.eq.8.and.abs(XM-ZB).le.DZB)then    ! X=ZB plane        
	        NXM=(XM+RXMAX)/DDX
	        NYM=(YM+RYMAX)/DDY
	if(NXM.ge.0.and.NXM.le.NOMX.and.NYM.ge.0.and.NYM.le.NOMY)then
	   	  NCOR=NCOR+1
     		  POR(NXM,NYM)=POR(NXM,NYM)+1.
		end if
	      end if    ! IPROC.eq.3
	    end if ! of (RR2.lt.
 320	    continue
	  end do    ! of J=NBG...
C----------------> ending IPROC>=5
	              end if ! RR.le.RB23
	            end if ! RR.le.RB13
	          end do  !  IML3=
		end if  ! RR.le.RB12
	      end do   ! IML2=
            end do ! IML1=
	  else      !  IPROC.ne.5
	  ITL=ITS(IO1(II))    ! type of "from" molecule
	  do IML=1,NSPEC(ITL)  ! cycle over "from" molecules
	  if(IPROC.eq.-1)then
*   This is only for DNA analysis
	     if(IO2(II).eq.0)go to 30
	     I1=IO1(II)
	     if(II.lt.10) then
 	       I2=IO1(II+1)
	       I3=IO1(II+10)
	       I4=IO1(II+11)
	     else if(II.eq.10)then
		I2=IO1(1)
		I3=IO1(20)
		I4=IO1(11)
	     else if(II.eq.11)then
		I2=IO1(20)
		I3=IO1(1)
		I4=IO1(10)
	     else
		I2=IO1(II-1)
		I3=IO1(II-10)
		I4=IO1(II-11)
	     end if
*   (0,0,0) point
	     E0(1)=0.25*(SX(I1)+SX(I2)+SX(I3)+SX(I4))
	     E0(2)=0.25*(SY(I1)+SY(I2)+SY(I3)+SY(I4))
	     E0(3)=0.25*(SZ(I1)+SZ(I2)+SZ(I3)+SZ(I4))
*   local coordinate system
             D1(1)=SX(I1)-SX(I3)
             D1(2)=SY(I1)-SY(I3)
             D1(3)=SZ(I1)-SZ(I3)
             D2(1)=SX(I2)-SX(I4)
             D2(2)=SY(I2)-SY(I4)
             D2(3)=SZ(I2)-SZ(I4)
	     if(D1(3).gt. HBOZL)D1(3)=D1(3)-BOZL
	     if(D1(3).lt.-HBOZL)D1(3)=D1(3)+BOZL
	     if(D2(3).gt. HBOZL)D2(3)=D2(3)-BOZL
	     if(D2(3).lt.-HBOZL)D2(3)=D2(3)+BOZL
	     if(IPRINT.gt.6)write(*,*)' base ',I1,I2,I3,I4
*   Other cases:
	  else if(IPROC.ge.0.and.IPROC.le.3)then
*   3 atom difining local coord.syst.   IPROC >= 0
	     ISHIFT=ISADDR(ITL)+(IML-1)*NSITS(ITL)-ISADR(ITL)
	     I=ISHIFT+IO1(II)
	     I1=ISHIFT+IO2(II)
	     I2=ISHIFT+IO3(II)
             D1(1)=SX(I1)-SX(I)
             D1(2)=SY(I1)-SY(I)
             D1(3)=SZ(I1)-SZ(I)
             D2(1)=SX(I2)-SX(I)
             D2(2)=SY(I2)-SY(I)
             D2(3)=SZ(I2)-SZ(I)
	     E0(1)=SX(I)
	     E0(2)=SY(I)
	     E0(3)=SZ(I)
	     call PBC(D1(1),D1(2),D1(3))
	     call PBC(D2(1),D2(2),D2(3))
	     if(IPRINT.ge.7)write(*,*)I,I1,I2,' ',NM(IO1(II)),
     +  NM(IO2(II)),NM(IO3(II))
C   specially for DNA - RMC calc.  DNA should be types 1,2
	  else if(IPROC.eq.4)then
C   calculating shift
	     XSA=0. 
	     YSA=0.
	     ZSA=0.
	     do ITYP=1,2
	       IBEG=ISADR(ITYP)+1
	       IEND=ISADR(ITYP+1)
	       do IS=IBEG,IEND
	         XSA=XSA+SX(IS)
		 YSA=YSA+SY(IS)
		 ZSA=ZSA+SZ(IS)
	       end do
	     end do
	     XSA=XSA/NREF
	     YSA=YSA/NREF
	     ZSA=ZSA/NREF
	     E0(1)=XSA-XR0
	     E0(2)=YSA-YR0
	     E0(3)=ZSA-ZR0
C   calculating turn around Z axis
	     FSH=0.
	     do ITYP=1,2
	       IBEG=ISADR(ITYP)+1
	       IEND=ISADR(ITYP+1)
	       do IS=IBEG,IEND
		 XREA=SX(IS)-XSA
		 YREA=SY(IS)-YSA
		 RREA=sqrt(XREA**2+YREA**2)
		 FREA=acos(XREA/RREA)
		 if(YREA.lt.0.)FREA=-FREA
		 FROT=FREA-FR(IS)
		 if(FROT.gt.PI/2.)FROT=FROT-PI
		 if(FROT.lt.-PI/2.)FROT=FROT+PI
		 FSH=FSH+FROT
	       end do
	     end do
	     FSH=FSH/NREF
	     if(IPRINT.ge.6)write(*,*)XSA,YSA,ZSA,FSH*TODGR
*  define vectors
	     EX(1)=cos(FSH)
	     EX(2)=sin(FSH)
	     EX(3)=0.
	     EY(1)=-sin(FSH)
	     EY(2)=cos(FSH)
	     EZ(3)=0.
	     EZ(1)=0.
	     EZ(2)=0.
	     EZ(3)=1.
	     go to 123
	  else
	     write(*,*)' wrong value of IPROC ',IPROC
	     stop
	  end if
	  call VECT(D1,D2,RV) ! normal v. to 123 plane  (Z axis)
	  call NORM(RV,EZ,RN,3)
	  RV(1)=D1(1)+D2(1)                 ! mediana of 213 angle  ( X axis)
	  RV(2)=D1(2)+D2(2)
	  RV(3)=D1(3)+D2(3)
	  call NORM(RV,EX,RN2,3)            !  X axis
	  call VECT(EZ,EX,EY)               !  Y axis
 123	  if(IPROC.le.0.or.IPROC.eq.4.or.IPROC.eq.5)
     +      call MEANSTR(II,IML,E0,EX,EY,EZ,IML,IML)
 	  JTYP=ITS(ISOR(IGR))
	  NBG=ISADDR(JTYP)+ISOR(IGR)-ISADR(JTYP)
	  NEN=ISADDR(JTYP+1)
	  NST=NSITS(JTYP)
	  do J=NBG,NEN,NST        ! over molecules with given site
	    if(J.eq.ISHIFT+IO1(II).or.J.eq.ISHIFT+IO2(II).or.
     +   ISHIFT+J.eq.IO3(II))go to 120
	    DX=SX(J)-E0(1)
	    DY=SY(J)-E0(2)
	    DZ=SZ(J)-E0(3)
*	    if(IPROC.eq.-1)then
*	      if(DZ.gt. HBOZL)DZ=DZ-BOZL 
*	      if(DZ.lt.-HBOZL)DZ=DZ+BOZL 
*	    else
	      call PBC(DX,DY,DZ)
*	    end if
	    RR2=DX**2+DY**2+DZ**2
            NCOR=NCOR+1
*   Calculating angularly average ion distribution around DNA
	    if(IPROC.eq.4)then
	       DRX=SX(J)-XSA
	       DRY=SY(J)-YSA
	       DRZ=0.
	       call PBC(DRX,DRY,DRZ)
	       RRA=sqrt(DRX**2+DRY**2)
	       NR=NA*RRA/RDFCUT+1
	       if(IPRINT.ge.7)write(*,*)I,J,RRA,NR
	       if(NR.le.NA)RDF(NR)=RDF(NR)+1.
	    end if
	    if(RR2.lt.ROMAX2)then
	      RR=sqrt(RR2)
              XM=EX(1)*DX+EX(2)*DY+EX(3)*DZ       ! X-coord in molec.c.s. 
              YM=EY(1)*DX+EY(2)*DY+EY(3)*DZ       ! Y-coord in molec.c.s. 
              ZM=EZ(1)*DX+EZ(2)*DY+EZ(3)*DZ       ! Z-coord in molec.c.s.
	      if(IPROC.le.0.or.IPROC.eq.4.or.IPROC.eq.5)then
*  calculate 3D density 
		 NXM=(XM+RXMAX)/DDX
		 NYM=(YM+RYMAX)/DDY
		 NZM=(ZM+RZMAX)/DDZ
		 if(NXM.ge.0.and.NXM.le.NOMX.and.NYM.ge.0.
     + and.NYM.le.NOMY.and.NZM.ge.0.and.NZM.le.NOMZ)then
     	           ID3(NXM,NYM,NZM)=ID3(NXM,NYM,NZM)+1
		   if(IPRINT.ge.7)write(*,*)I,J,NXM,NYM,NZM,XM,YM,ZM
		 end if
	      else if(IPROC.eq.1.and.abs(abs(ZM)-ZB).le.DZB)then  
* case of Z=ZB plane            
	        NXM=(XM+RXMAX)/DDX
	        NYM=(YM+RYMAX)/DDY
		if(IPRINT.ge.7)write(*,*)I,J,NXM,NYM,NZM,XM,YM,ZM
	if(NXM.ge.0.and.NXM.le.NOMX.and.NYM.ge.0.and.NYM.le.NOMY)then
	   	  NCOR=NCOR+1
     		  POR(NXM,NYM)=POR(NXM,NYM)+1.
		end if
	      end if
	      if(IPROC.eq.2.and.abs(YM-ZB).le.DZB)then   ! Y=ZB plane         
	        NXM=(XM+RXMAX)/DDX
	        NYM=(YM+RYMAX)/DDY
		if(IPRINT.ge.7)write(*,*)I,J,NXM,NYM,NZM,XM,YM,ZM
	if(NXM.ge.0.and.NXM.le.NOMX.and.NYM.ge.0.and.NYM.le.NOMY)then
	   	  NCOR=NCOR+1
     		  POR(NXM,NYM)=POR(NXM,NYM)+1.
		end if
	      end if
	      if(IPROC.eq.3.and.abs(XM-ZB).le.DZB)then    ! X=ZB plane        
	        NXM=(XM+RXMAX)/DDX
	        NYM=(YM+RYMAX)/DDY
	if(NXM.ge.0.and.NXM.le.NOMX.and.NYM.ge.0.and.NYM.le.NOMY)then
	   	  NCOR=NCOR+1
     		  POR(NXM,NYM)=POR(NXM,NYM)+1.
		end if
	      end if    ! IPROC.eq.3
	    end if     !  RR2.lt.ROMAX
		  if(NCOR.le.0)then
		     write(*,*)' Integer overflow!!!'
		     stop
		  end if
 120	    continue
	    end do     !  J=NBG    
	  end do      !  IML=
 30	  continue
	  end if    ! IPROC.eq.5
	  end do
*  Mark hydrogens of the water molecule 
	  DX1=0.
	  DY1=1.
	  DZ1=0.
	  XN2=1.
	  YN2=0.
	  ZN2=0.
	  RRH2=DX1**2+DY1**2+DZ1**2
	  RRH=sqrt(RRH2)
	  CF=(DX1*XN2+DY1*YN2+DZ1*ZN2)/(RN2*RRH)
	  XM=RRH*CF                   
	  YM=sqrt(RRH2-XM**2)  
	  NXM=(XM+RXMAX)/DDX
	  NYM=YM/DDY  
	  if(IPROC.eq.1.and.XM+RXMAX.gt.0.d0.and.NXM.le.NOMX*2
     +    .and.NYM.le.NOMY)
     +    POR(NXM,NYM)=POR(NXM,NYM)+1.
	  if(IPROC.eq.2.and.NXM.ge.0.and.NXM.le.NOMX*2)
     +    POR(NXM,0)=POR(NXM,0)+1.
	  if(IPROC.eq.3.and.NYM.le.NOMY)
     +    POR(IZY,NYM)=POR(IZY,NYM)+1.
	end do
	return
	end
*
*==================== MCOR3 ==========================================
*
	subroutine MCOR3 
	include 'tranal.h'
	dimension ZI(0:NMX)
c     
	write(*,*)' Enter MCOR3'
        NB12=(sqrt(RB12)-RMIN12)/DR12+1 
	NOP3=0
	do I=1,NDUR
	  NOP3=NOP3+NSPEC(ITS(IS3(I)))
	end do
	if(LCOL2)then
	  NOP4=0
	  do I=NDUR+1,NDUP
	    NOP4=NOP4+NSPEC(ITS(IS3(I))) 
	  end do
	end if
	X0=-RMAXX             ! koord. polya vyvoda
	X1= RMAXX
	Y0=-RMAXY
	Y1= RMAXY             
	XA1=-0.5*RB12
	XA2=-XA1              ! koord. pervogo i vtorogo atomov
	YA1=0.               
	YA2=0.
	FCC=1.
*	if(IS1(1).eq.IS2(1))FCC=2.   
*   Write data file for 3-d plot (Mathematica)
	open(unit=15,file='3cor.data',status='unknown')  
 201  format(202f10.4) 
	do IYT=-NRY,NRY
	  IY=iabs(IYT)
	  Y3=IYT*DYY
	  YIY=(IY+0.5)*DYY             
	  SH3=abs(2.*PI*DXX*DYY*YIY)
	  FACR=NDUP*VOL/(COR2*NOP3*SH3*FCC) 
	  do IX=0,NRX
	    X3=IX*DXX-RMAXX     
	    ZI(IX)=P3COR(IX,IY)*FACR
	    if(IPRINT.ge.7)write(15,'(3f10.5)')X3,Y3,ZI
	  end do
	  write(15,201)(ZI(I),I=0,NRX)
	end do 
	close(15)
	write(*,*)' num. of part.',NOP3,NOP4
	do IYT=0,NTY             ! abs. coord. na grafike    
        YI=(IYT+0.5)*RMAXY/NTY 
	  IY=YI/DYY
	  YIY=(IY+0.5)*DYY             
	  SH3=abs(2.*PI*DXX*DYY*YIY)
	  FACR=NDUP*VOL/(COR2*NOP3*SH3*FCC)
	  if(LCOL2)FAC2=NDUP*VOL/(COR2*NOP4*SH3*FCC)  
	  if(IPRINT.ge.5)write(*,*)IYT,FACR,FAC2
	  do IXT=-NTX,NTX
	    XI=(IXT+0.5)*RMAXX/NTX               ! dec.coord.tochki
	    IX=(XI-X0)/DXX+0.001
	    if(IX.le.NRX.and.IX.ge.0.and.IY.le.NRY.and.IY.ge.0)then
	      COREL=P3COR(IX,IY)*FACR
	      CORE2=P3CO2(IX,IY)*FAC2
	    else
	      COREL=0.               
	      CORE2=0.
	    end if 
	    if(LCOL2)then
 	      ICOL=NCOLOR2(COREL,CORE2,AMPL,MAXCOLOR)
	      if(IPRINT.ge.6)write(*,'(2I4,2f8.3,2x,2I5,2f12.6,I5)')
     +IX,IY,XI,YI,IXT,IYT,COREL,CORE2,ICOL
	    else
   	      ICOL=NCOLOR(COREL,AMPL,MAXCOLOR) 
	      if(ICOL.gt.MAXCOLOR)ICOL=MAXCOLOR
	      if(IPRINT.ge.6)write(*,'(2I4,2f8.3,2x,2I5,f12.6,I5)')
     +IX,IY,XI,YI,IXT,IYT,COREL,ICOL
	    end if
          ITAB(IYT,IXT)=ICOL 
	  end do
	end do
*  Mark point 1,2
	IX1=XA1*NTX/RMAXX
	IX2=XA2*NTX/RMAXX
	IY =YA1*NTY/RMAXY 
	if(LCOL2)then
	  ITAB(IY,IX1)=(MAXCOLOR+1)**2
	  ITAB(IY,IX2)=(MAXCOLOR+1)**2
	  call MAKEPS2(fil3cor,IX1,IX2,IY)
	else
	  ITAB(IY,IX1)=MAXCOLOR
	  ITAB(IY,IX2)=MAXCOLOR
	  call MAKEPS(fil3cor,IX1,IX2,IY)
	end if
	return
	end
*
*=================== MORI ===============================
*
	subroutine MORI 
	include 'tranal.h'  
	real*8 TMP(0:NOMXM)
	X0=-RXMAX+DDX			! koord. polya vyvoda
	X1= RXMAX
	Y0=-RYMAX+DDY
	Y1= RYMAX
	Z0=-RZMAX+DDZ
	Z1= RZMAX
	open(unit=31,file=filori,status='unknown')
C   writing angularly averaged density distribution
	if(IPROC.eq.4)then
	  open(unit=16,file='dist.dat',status='unknown')
	  CONU=0.
	  write(16,*)'#   distribution of',NM(ISOR(1))
	  FACT=1.d27/(AVSNO*IAN)
	  do I=1,NA
	    RR=(I-0.5)*RDFCUT/NA
	    DRR=RDFCUT/NA
  	    SH12=2.*PI*DRR*RR*BOZL
	    CONU=CONU+RDF(I)/(20*IAN)
	    RDFM=RDF(I)*FACT/SH12
	    RDFU=RDF(I)*VOL/(SH12*NSPEC(ITS(ISOR(1)))*IAN)
	    if(CONU.gt.1.d-8)write(16,'(f8.3,3f12.5)')
     +      RR,RDFM,RDFU,CONU
	  end do
	  close(16)
	end if
	if(IPROC.le.0.or.IPROC.eq.4.or.IPROC.eq.5)then
*  writing 3D density in gOpenMol format
	   open(unit=31,file=filori,status='unknown')
	   N3=3
	   N200=200
	   write(31,*)N3,N200
	   write(31,*)NOMZ,NOMY,NOMX
	   write(31,'(6e13.5)')Z0,Z1,Y0,Y1,X0,X1
	   FACORI=VOL/(DDX*DDY*DDZ*NCOR)
	   write(*,*)' writing 3D distribution ...'
	   write(*,'(i8,3f8.2,3f8.4,e13.5)')
     +NCOR,RXMAX,RYMAX,RZMAX,DDX,DDY,DDZ,FACORI
	   do IZ=1,NOMZ
	      do IY=1,NOMY
		 do IX=1,NOMX
		    TMP(IX)=ID3(IX,IY,IZ)*FACORI
		 end do
		 write(31,'(6e13.5)')(TMP(IX),IX=1,NOMX)
	      end do
	   end do
	   close(31)
	      open(unit=32,file=fcrd,status='unknown')
	      write(32,'(i5,a)')NMSTR,
     &   '      average structure from MolDynamix'
	      write(32,'(a)')
     +'At        x       y        z     ...        RMS'
	      I1=1
	      do I=1,NMSTR
	        XX=XAV(I)/IAA(I)
		XX2=abs(XAV2(I)/IAA(I)-XX**2)
	        YY=YAV(I)/IAA(I)
		YY2=abs(YAV2(I)/IAA(I)-YY**2)
	        ZZ=ZAV(I)/IAA(I)
		ZZ2=abs(ZAV2(I)/IAA(I)-ZZ**2)
		RR=sqrt(XX2+YY2+ZZ2)
		write(32,'(a5,3f8.4,4x,f9.5)')NMM(I),XX,YY,ZZ,RR
	      end do
	      close(32)
	   return
	end if
	XA=0.
	YA=0. 
	NOP2=2*NOP
	NH2O=NSPEC(ITS(IO1(1)))
	NMOL=NSPEC(ITS(ISOR(1))) 
	if(DZB.ge.ZB)then 
	  SH=4.d0*DDO**2*(DZB+ZB)
	else
	  SH=8.d0*DDO**2*DZB
	end if
	FACR=NXM*NYM*1./NCOR
*	FACR=VOL/(NH2O*NMOL*SH*IAN)               
	do IY=0,NOMY
*	  do IX=0,NOMX
*	    COREL=POR(IX,IY)*FACR 
* 	    ICOL=NCOLOR(COREL,AMPL,MAXCOLOR)
*	    if(ICOL.gt.MAXCOLOR)ICOL=MAXCOLOR
*            if(IPRINT.ge.6)write(*,'(2I4,2f8.3,2x,2I5,f12.6,I5)')
*     +IX,IY,XI,YI,IXT,IYT,COREL,ICOL
*	    ITAB(IYT,IXT)=ICOL
*	  end do
	  write(31,'(500f8.4)')(POR(IX,IY)*FACR,IX=0,NOMX)
	end do
*  Mark C.O.
*	IX =XA*NTX/ROMAX
*	IY =YA*NTY/ROMAX  
*	ITAB(IX,IY)=MAXCOLOR
*	call MAKEPS(filori)
	return
	end
*
*======================== MEANSTR ====================================
* 
	subroutine MEANSTR(II,IML,E0,EX,EY,EZ,IML2,IML3)
	include 'tranal.h'
	dimension E0(3),EX(3),EY(3),EZ(3)
*  Sum over atoms which mean positions should be defined
	if(IO3(II).eq.0)return
**	do I=1,NMSTR
	I=1
 5	if(I.gt.NMSTR)go to 20
	   IIS=ICF(II)
	   ISS=ISM(I,IIS)           ! site
	   ITL=ITS(IO1(II))    ! type of "from" molecule
 	   if(IPROC.eq.5)then
 	      ITYP=ITS(ISS)
 	      if(ISREP(I).eq.-1)IML=IML2
 	      if(ISREP(I).eq.-2)IML=IML3
 	      IS=ISADDR(ITYP)+(IML-1)*NSITS(ITYP)+ISS-ISADR(ITYP)
 	   else
	     ISHIFT=ISADDR(ITL)+(IML-1)*NSITS(ITL)-ISADR(ITL)
	     IS=ISS+ISHIFT
 	   end if
	   NMM(I)=NM(NSITE(IS))(1:2)
	   DX=SX(IS)-E0(1)
	   DY=SY(IS)-E0(2)
	   DZ=SZ(IS)-E0(3)
	   if(IPROC.ne.4)call PBC(DX,DY,DZ)
	   XL=DX*EX(1)+DY*EX(2)+DZ*EX(3)
	   YL=DX*EY(1)+DY*EY(2)+DZ*EY(3)
	   ZL=DX*EZ(1)+DY*EZ(2)+DZ*EZ(3)
	   if(ISREP(I).gt.1.and.IAA(I).gt.0)then
*   check the next atom and accumulated average
	     I1=I+1
	     ISS2=ISM(I1,IIS)+ISHIFT
	     DX2=SX(ISS2)-E0(1)
	     DY2=SY(ISS2)-E0(2)
	     DZ2=SZ(ISS2)-E0(3)
	     if(IPROC.eq.0)call PBC(DX2,DY2,DZ2)
	     XL2=DX2*EX(1)+DY2*EX(2)+DZ2*EX(3)
	     YL2=DX2*EY(1)+DY2*EY(2)+DZ2*EY(3)
	     ZL2=DX2*EZ(1)+DY2*EZ(2)+DZ2*EZ(3)
	     AX0=XAV(I)/IAA(I)
	     AY0=YAV(I)/IAA(I)
	     AZ0=ZAV(I)/IAA(I)
	     AX1=XAV(I1)/IAA(I1)
	     AY1=YAV(I1)/IAA(I1)
	     AZ1=ZAV(I1)/IAA(I1)
	     RR1=(XL-AX0)**2+(YL-AY0)**2+(ZL-AZ0)**2           !  1->1
	     RR2=(XL2-AX0)**2+(YL2-AY0)**2+(ZL2-AZ0)**2        !  2->1
	     RR11=(XL-AX1)**2+(YL-AY1)**2+(ZL-AZ1)**2          !  1->2
	     RR21=(XL2-AX1)**2+(YL2-AY1)**2+(ZL2-AZ1)**2       !  2->2
	     if(ISREP(I).eq.3)then
	       I2=I+2
	       ISS3=ISM(I2,IIS)+ISHIFT
	       DX3=SX(ISS3)-E0(1)
	       DY3=SY(ISS3)-E0(2)
	       DZ3=SZ(ISS3)-E0(3)
               if(IPROC.ne.4)call PBC(DX3,DY3,DZ3)
	       AX2=XAV(I2)/IAA(I2)
	       AY2=YAV(I2)/IAA(I2)
	       AZ2=ZAV(I2)/IAA(I2)
	       XL3=DX3*EX(1)+DY3*EX(2)+DZ3*EX(3)
	       YL3=DX3*EY(1)+DY3*EY(2)+DZ3*EY(3)
	       ZL3=DX3*EZ(1)+DY3*EZ(2)+DZ3*EZ(3)
	       RR3 =(XL3-AX0)**2+(YL3-AY0)**2+(ZL3-AZ0)**2       !  3->1
	       RR31=(XL3-AX1)**2+(YL3-AY1)**2+(ZL3-AZ1)**2       !  3->2
	       RR32=(XL3-AX2)**2+(YL3-AY2)**2+(ZL3-AZ2)**2       !  3->3
	       RR12=(XL -AX2)**2+(YL -AY2)**2+(ZL -AZ2)**2       !  1->3
	       RR22=(XL2-AX2)**2+(YL2-AY2)**2+(ZL2-AZ2)**2       !  2->3
*  evaluation of different transpositions
	       ICS=1
	       R123=RR1+RR21+RR32
	       RMIN=R123
	       R213=RR2+RR11+RR32
	       if(R213.lt.RMIN)then
		  ICS=2
		  RMIN=R213
	       end if
	       R132=RR1+RR31+RR22
	       if(R132.lt.RMIN)then
		  ICS=3
		  RMIN=R132
	       end if
	       R231=RR11+RR31+RR12
	       if(R231.lt.RMIN)then
		  ICS=4
		  RMIN=R231
	       end if
	       R312=RR3+RR11+RR22
	       if(R312.lt.RMIN)then
		  ICS=5
		  RMIN=R312
	       end if
	       R321=RR3+RR21+RR12
	       if(R321.lt.RMIN)ICS=6
	       if(ICS.eq.2.or.ICS.eq.4)then       !   2 -> 1
		  XAV(I)=XAV(I)+XL2
		  YAV(I)=YAV(I)+YL2
		  ZAV(I)=ZAV(I)+ZL2
	          XAV2(I)=XAV2(I)+XL2**2
	          YAV2(I)=YAV2(I)+YL2**2
	          ZAV2(I)=ZAV2(I)+ZL2**2
	if(IPRINT.ge.7)write(*,'(3I5,a4,3f9.3)')
     +  I,IS,ICS,NM(NSITE(IS)),XL2,YL2,ZL2
	          IAA(I)=IAA(I)+1
		  if(ICS.eq.2)then              !  1->2  3
		     I1=I+1
		     I2=I+2
		  else       !  ICS=4              3->2; 1->3
		     I1=I+2
		     I2=I+1
		  end if
		  XAV(I1)=XAV(I1)+XL
		  YAV(I1)=YAV(I1)+YL
		  ZAV(I1)=ZAV(I1)+ZL
	if(IPRINT.ge.7)write(*,'(3I5,a4,3f9.3)')
     +  I,ISS2,ICS,NM(NSITE(ISS2)),XL,YL,ZL
	          XAV2(I1)=XAV2(I1)+XL**2
	          YAV2(I1)=YAV2(I1)+YL**2
	          ZAV2(I1)=ZAV2(I1)+ZL**2
		  XAV(I2)=XAV(I2)+XL3
		  YAV(I2)=YAV(I2)+YL3
		  ZAV(I2)=ZAV(I2)+ZL3
	if(IPRINT.ge.7)
     +write(*,'(3I5,a4,3f9.3)')I,ISS3,ICS,NM(NSITE(ISS3)),XL3,YL3,ZL3
	          XAV2(I2)=XAV2(I2)+XL3**2
	          YAV2(I2)=YAV2(I2)+YL3**2
	          ZAV2(I2)=ZAV2(I2)+ZL3**2
		  IAA(I1)=IAA(I1)+1
		  IAA(I2)=IAA(I2)+1
		  I=I+2
		  go to 10
	       else if (ICS.ge.5)then   !        3 -> 1
		  XAV(I)=XAV(I)+XL3
		  YAV(I)=YAV(I)+YL3
		  ZAV(I)=ZAV(I)+ZL3
	          XAV2(I)=XAV2(I)+XL3**2
	          YAV2(I)=YAV2(I)+YL3**2
	          ZAV2(I)=ZAV2(I)+ZL3**2
	if(IPRINT.ge.7)write(*,'(3I5,a4,3f9.3)')
     +I,IS,ICS,NM(NSITE(IS)),XL3,YL3,ZL3
	          IAA(I)=IAA(I)+1
		  if(ICS.eq.5)then                !    312
		     I1=I+1
		     I2=I+2
		  else   !   ICS=6                     321
		     I1=I+2
		     I2=I+1
		  end if
		  XAV(I1)=XAV(I1)+XL
		  YAV(I1)=YAV(I1)+YL
		  ZAV(I1)=ZAV(I1)+ZL
	if(IPRINT.ge.7)write(*,'(3I5,a4,3f9.3)')
     +I,ISS2,ICS,NM(NSITE(ISS2)),XL,YL,ZL
	          XAV2(I1)=XAV2(I1)+XL**2
	          YAV2(I1)=YAV2(I1)+YL**2
	          ZAV2(I1)=ZAV2(I1)+ZL**2
		  XAV(I2)=XAV(I2)+XL2
		  YAV(I2)=YAV(I2)+YL2
		  ZAV(I2)=ZAV(I2)+ZL2
	if(IPRINT.ge.7)
     +  write(*,'(3I5,a4,3f9.3)')I,ISS3,ICS,NM(NSITE(ISS3)),XL2,YL2,ZL2
	          XAV2(I2)=XAV2(I2)+XL2**2
	          YAV2(I2)=YAV2(I2)+YL2**2
	          ZAV2(I2)=ZAV2(I2)+ZL2**2
		  IAA(I1)=IAA(I1)+1
		  IAA(I2)=IAA(I2)+1
		  I=I+2
		  go to 10
	       end if     ! (RR2.lt.RR1.and.RR2.lt.RR3
	     else if((RR1+RR21).gt.(RR2+RR11)) then  !   ISREP=2,  1 <-> 2
	       I1=I+1
	       XAV(I1)=XAV(I1)+XL
	       YAV(I1)=YAV(I1)+YL
	       ZAV(I1)=ZAV(I1)+ZL
	       if(IPRINT.ge.7)
     + write(*,'(2I5,a4,3f9.3)')I1,ISS2,NM(NSITE(ISS2)),XL,YL,ZL
	       XAV2(I1)=XAV2(I1)+XL**2
	       YAV2(I1)=YAV2(I1)+YL**2
	       ZAV2(I1)=ZAV2(I1)+ZL**2
	       XAV(I)=XAV(I)+XL2
	       YAV(I)=YAV(I)+YL2
	       ZAV(I)=ZAV(I)+ZL2
	if(IPRINT.ge.7)write(*,'(2I5,a4,3f9.3)')
     +I,IS,NM(NSITE(IS)),XL2,YL2,ZL2
	       XAV2(I)=XAV2(I)+XL2**2
	       YAV2(I)=YAV2(I)+YL2**2
	       ZAV2(I)=ZAV2(I)+ZL2**2
	       IAA(I)=IAA(I)+1
	       IAA(I1)=IAA(I1)+1
	       I=I+1
	       go to 10
	     end if   !  ISEP.eq.3
	   end if     !  ISEP.ne.1
	   XAV(I)=XAV(I)+XL
	   YAV(I)=YAV(I)+YL
	   ZAV(I)=ZAV(I)+ZL
	   if(IPRINT.ge.7)write(*,'(2I5,a4,3f9.3)')
     +I,IS,NM(NSITE(IS)),XL,YL,ZL
	   XAV2(I)=XAV2(I)+XL**2
	   YAV2(I)=YAV2(I)+YL**2
	   ZAV2(I)=ZAV2(I)+ZL**2
	   IAA(I)=IAA(I)+1
 10	   I=I+1
	   go to 5
*	end do
 20	   return
	end
*          
*========================= DIFFUS ======================================
*
      subroutine DIFFUS
      include 'tranal.h'
      data IREC/1/,IINIT/0/,JINIT/0/
*  calculation of diffusion coefficients 
      ITYP		= IDF
      N           = ISADDR(ITYP)
      I           = IADDR(ITYP)
      IML=NSPEC(ITYP)
	XCM=0.
	YCM=0.
	ZCM=0.
      if(IML.gt.MAXMOL)IML=MAXMOL
      DO J        = 1,IML   ! sum over molecules
	NSADR=ISADDR(ITYP)+NSITS(ITYP)*(J-1)+IAT
        I           = I+1
        XX       = SX(NSADR)
        YY       = SY(NSADR)
        ZZ       = SZ(NSADR)
**Calculate C.O.M. vectors relative to the first atom:
**        DO IS       = NSBEG,NSEND
**          N           = N+1
**          XX       = XX+MASS(IS)*SX(N)
**          YY       = YY+MASS(IS)*SY(N)
**          ZZ       = ZZ+MASS(IS)*SZ(N)
**        END DO! OF IS
        XX       = XX+ISHX(J)*BOXL
        YY       = YY+ISHY(J)*BOYL
        ZZ       = ZZ+ISHZ(J)*BOZL
*  PBC**(-1)
	  if(IINIT.ne.0.or.IREC.ne.1)then
	    IREC1=IREC-1
	    if(IREC1.le.0)IREC1=IREC1+MTR 
	    if(XX-TRCX(IREC1,J).gt. HBOXL)then
	      ISHX(J)=ISHX(J)-1
	      XX=XX-BOXL
	    end if
	    if(XX-TRCX(IREC1,J).lt.-HBOXL)then
	      ISHX(J)=ISHX(J)+1
	      XX=XX+BOXL
	    end if
	    if(YY-TRCY(IREC1,J).gt. HBOYL)then
	      ISHY(J)=ISHY(J)-1
	      YY=YY-BOYL
	    end if
	    if(YY-TRCY(IREC1,J).lt.-HBOYL)then
	      ISHY(J)=ISHY(J)+1
	      YY=YY+BOYL
	    end if
	    if(ZZ-TRCZ(IREC1,J).gt. HBOZL)then
	      ISHZ(J)=ISHZ(J)-1
	      ZZ=ZZ-BOZL
	    end if
	    if(ZZ-TRCZ(IREC1,J).lt.-HBOZL)then
	      ISHZ(J)=ISHZ(J)+1
	      ZZ=ZZ+BOZL
	    end if
	  end if	  
*  remember 
	  TRCX(IREC,J)=XX	  
	  TRCY(IREC,J)=YY	  
	  TRCZ(IREC,J)=ZZ  
	  JM=J
	  XCM=XCM+XX
	  YCM=YCM+YY
	  ZCM=ZCM+ZZ
      END DO! OF J
      XCM=XCM/IML
      YCM=YCM/IML
      ZCM=ZCM/IML
	if(JINIT.eq.0)then
	   XCM0=XCM
	   YCM0=YCM
	   ZCM0=ZCM
	   JINIT=1
	end if
      TTIM(IREC)=FULTIM*1.d-12            ! in  s
*      if(IPRINT.ge.6)write(*,'(4f10.3,I7,2x,3I3)')
*     +FULTIM,TRCX(IREC,ICNT),TRCY(IREC,ICNT),TRCZ(IREC,ICNT),
*     +IREC,ISHX(ICNT),ISHY(ICNT),ISHZ(ICNT)
	if(IPRINT.ge.6)write(*,'(f12.1,3f12.6)')
     +    FULTIM,XCM-XCM0,YCM-YCM0,ZCM-ZCM0
*  calculate <R(t)-R(0)>
	IRB=IREC  
	IRB1=IRB+1
	if(IRB1.gt.MTR)IRB1=1
	IROUND=0
	do ITM=1,NTT
	  TBACK=FULTIM*1.d-12-ITM*DTT
*	  write(*,*)ITM,FULTIM,TBACK*1.d12,IRB,TTIM(IRB)*1.d12,IRB1,
*     + TTIM(IRB1)*1.d12
 10	  if(TTIM(IRB).le.TBACK)then
	    if(TTIM(IRB1)-TTIM(IRB).lt.5.*DTT)then
	    AL=(TBACK-TTIM(IRB))/(TTIM(IRB1)-TTIM(IRB))      
	    if(AL.lt.0.d0.or.AL.gt.1.d0)write(*,'(a,f9.5,I7,3e14.5)')
     +  ' strange ALPHA: ',AL,IRB,TTIM(IRB),TBACK,TTIM(IRB1)  
          DO J        = 1,IML   ! sum over molecules
	      X0=TRCX(IRB,J)*(1.-AL)+TRCX(IRB1,J)*AL
	      Y0=TRCY(IRB,J)*(1.-AL)+TRCY(IRB1,J)*AL
	      Z0=TRCZ(IRB,J)*(1.-AL)+TRCZ(IRB1,J)*AL
	      RAX=(X0-TRCX(IREC,J))**2
	      RAY=(Y0-TRCY(IREC,J))**2
	      RAZ=(Z0-TRCZ(IREC,J))**2
	      RR=RAX+RAY+RAZ
	      RCUMX(ITM)=RCUMX(ITM)+RAX
	      RCUMY(ITM)=RCUMY(ITM)+RAY
	      RCUMZ(ITM)=RCUMZ(ITM)+RAZ
	      RCUM(ITM)=RCUM(ITM)+RR
	      NCUM(ITM)=NCUM(ITM)+1  
	      if(IPRINT.ge.8)write(*,'(2I6,2f12.6)')
     +      ITM,J,ITM*DTT*1.d12,sqrt(RR)
	    end do   
	    end if
	  else
	    IRB1=IRB
	    IRB=IRB-1
	    if(IRB.le.0)then
	      if(IINIT.eq.0)go to 30
	      IRB=MTR
	      IROUND=1
	    end if
	    if(IRB.le.IREC.and.IROUND.eq.1)go to 30
	    go to 10
	  end if
	end do ! of ITM
 30	IREC=IREC+1
	if(IREC.gt.MTR)then
	  IREC=1
	  IINIT=1
	end if
	return
	end   
*
*==================== RESTIM ==========================================
*                                                                      
	subroutine RESTIM(IMD)
	include 'tranal.h'
	real*4 TIIN(NRT1M,NRT2M),TIINI(NRT1M,NRT2M),TIINO(NRT1M,NRT2M)
	integer IRS(NRT1M,NRT2M)
	data IINIT/0/
	if(IINIT.eq.0)then
	  IINIT=1
	  do I=1,NRT1M
	    do J=1,NRT2M
	      IRS(I,J)=0
	    end do
	  end do 
	end if 
	if(IBREAK.ne.0)then
	  do I=1,NRT1
	    do J=1,NRT2
	      IRS(I,J)=0
	    end do
	  end do 
	  write(*,*)' residence time tables set to zero'
	end if     
*   over first set of sites
	do I=1,NRT1
	  ISP=IRS1(I)
	  ITYP=ITYPE(ISP)
	  IMOL=NNUM(ISP)
	  if(LIST(ITYP).eq.0)return
*   over second set of sites
	  do J=1,NRT2
	    JSP=IRS2(J) 
	    JMOL=NNUM(JSP)
	    if(IMOL.ne.JMOL)then
	    JTYP=ITYPE(JSP)
	    if(LIST(JTYP).eq.0)return
	    if(ISP.eq.JSP)go to 90
	    DX=SX(ISP)-SX(JSP)
	    DY=SY(ISP)-SY(JSP)
	    DZ=SZ(ISP)-SZ(JSP)
	    call PBC(DX,DY,DZ)
	    RR=sqrt(DX**2+DY**2+DZ**2)
*  executed at the last call
	    if(IMD.eq.1)then
*  register all pairs which are still in contact
	      if(mod(IRS(I,J),3).ne.0)then
	        TIMR=(FULTIM*1.d-12-TIINI(I,J))*1.d12
	        TIMRS2=TIMRS2+TIMR     ! register residence time 
	        NR=TIMR*NITT/TIMM+1
		write(*,*)' add ',TIMR,' ps  for ',I,J,' R=',RR
	        if(NR.gt.0.and.NR.le.NITT)DIST2(NR)=DIST2(NR)+1 
	        ITIR2=ITIR2+1
	        if(TIMR.gt.TTER*1.d12)then
	          TIMRS1=TIMRS1+TIMR
	 	  ITIR1=ITIR1+1
		end if
	        TIMRS=TIMRS+TIMR     
	        if(NR.gt.0.and.NR.le.NITT)DISTT(NR)=DISTT(NR)+1 
	        ITIR=ITIR+1
	      end if
	      go to 90
	    end if    ! IMD.eq.1
	    if(IPRINT.ge.8)write(*,*)I,J,ISP,JSP,RR
*  standard criteria (exit during short time not accounted)
 15	    if(mod(IRS(I,J),3).eq.0)then 
*  bulk (0) -> enter hydrated shell (2)
	      if(RR.gt.RRN.and.RR.lt.RRX)then
		IRS(I,J)=IRS(I,J)+2
	 	TIINI(I,J)=FULTIM*1.d-12          ! register entrance time
	        if(IPRINT.ge.6)write(*,*)' new st',I,J
	      end if   
*  Temporarly out (1)
	    else if(mod(IRS(I,J),3).eq.1)then 
*  Out more than cut-off time (TTER) -> bulk (0) 
	      if(FULTIM*1.d-12-TIINO(I,J).gt.TTER)then
	        IRS(I,J)=IRS(I,J)-1
	        if(IPRINT.ge.6)write(*,*)' out st',I,J
	        TIMR=(TIINO(I,J)-TIINI(I,J))*1.d12
	        TIMRS2=TIMRS2+TIMR     ! register residence time 
	        NR=TIMR*NITT/TIMM+1
	        if(NR.gt.0.and.NR.le.NITT)DIST2(NR)=DIST2(NR)+1 
	        ITIR2=ITIR2+1
	        if(TIMR.gt.TTER*1.d12)then
	          TIMRS1=TIMRS1+TIMR
	 	  ITIR1=ITIR1+1
		end if
	 	go to 15
	      end if
	      if(RR.gt.RRN.and.RR.lt.RRX)IRS(I,J)=IRS(I,J)+1
*  hydrated (2)
	    else
	      if(RR.le.RRN.or.RR.ge.RRX)then
*  mark as temporarly out (1); register exit time 
	        IRS(I,J)=IRS(I,J)-1
	        TIINO(I,J)=FULTIM*1.d-12
            end if
	    end if	    
*  alt. criteria (just register in - out )	     
	    if(IRS(I,J).le.2)then
* simple in
	      if(RR.gt.RRNX.and.RR.lt.RRXN)then
	        IRS(I,J)=IRS(I,J)+3
	        TIIN(I,J)=FULTIM*1.d-12 
	        if(IPRINT.ge.6)write(*,*)' new alt',I,J
	      end if
	    else
* simple out    
	      if(RR.lt.RRNN.or.RR.gt.RRXX)then 
	        TIMR=(FULTIM*1.d-12-TIIN(I,J))*1.d12
		IRS(I,J)=IRS(I,J)-3
	        TIMRS=TIMRS+TIMR     
	        NR=TIMR*NITT/TIMM+1
	        if(NR.gt.0.and.NR.le.NITT)DISTT(NR)=DISTT(NR)+1 
	        ITIR=ITIR+1
	        if(IPRINT.ge.6)write(*,*)' out alt',I,J
	      end if
	    end if
*  Count hydrated pairs
	    if(mod(IRS(I,J),3).eq.2)IHP=IHP+1
 90	    continue
	  end if ! (IMOL.ne.JMOL
	  end do
	end do
	if(IPRINT.ge.7)write(*,*)fultim,ITIR,TIMRS/ITIR
      return
	end
*
*=================== MDIFF ============================================
*                                                                      
	subroutine MDIFF(fildif)
	include 'tranal.h'
	character*12 fildif
	open(unit=9,file=fildif,status='unknown')
	write(*,*)
     +'translational time -correlation function of type',IDF
	write(9,'(a)')' D units is 10**-9 m**2/s '
	write(9,'(a,I3)')
     +'#  translational time -correlation function of type',IDF
	write(9,*)'  t(ps)  Dav    Ddif       R(A)  Dx     Dy     Dz'
	write(*,*)NTT 
	TSHO=0.
	do I=1,NTT
	  TIM=I*DTT*1.d12
	  if(NCUM(I).gt.0)then
	    TCOR=10.*RCUM(I)/(6.d0*TIM*NCUM(I))
	    TCX=10.*RCUMX(I)/(2.d0*TIM*NCUM(I))
	    TCY=10.*RCUMY(I)/(2.d0*TIM*NCUM(I))
	    TCZ=10.*RCUMZ(I)/(2.d0*TIM*NCUM(I))
	    TSH2=RCUM(I)/NCUM(I)
	    TSH=sqrt(TSH2)
	    TSD=1.d-11*TSH*(TSH-TSHO)/(3.*DTT) 
	    TSHO=TSH
            write(9,'(f10.3,2f10.5,f10.3,3f10.5,i9)')
     +TIM,TCOR,TSD,TSH,TCX,TCY,TCZ,NCUM(I)
      write(*,'(f10.3,2f10.5,f10.3,3f10.5,i9)')
     +TIM,TCOR,TSD,TSH,TCX,TCY,TCZ,NCUM(I)
	  end if
	end do
	return
	end                                               
*
*=================== TAKETOR ============================================
*                                                                        
	subroutine TAKETOR
	include "tranal.h"
*  Torsion angle distributions
	do ITYP=1,NAG 
	  do N=IADT(ITYP)+1,IADT(ITYP+1)
        I         = IT(N)
        J         = JT(N)
        K         = KT(N)
        L         = LT(N)
        ax        = sx(j)-sx(i)
        ay        = sy(j)-sy(i)
        az        = sz(j)-sz(i)
        bx        = sx(k)-sx(j)
        by        = sy(k)-sy(j)
        bz        = sz(k)-sz(j)
        cx        = sx(l)-sx(k)
        cy        = sy(l)-sy(k)
        cz        = sz(l)-sz(k)
*
        call PBC(AX,AY,AZ)
        call PBC(BX,BY,BZ)
        call PBC(CX,CY,CZ)
*
        ab        = ax*bx + ay*by + az*bz
        bc        = bx*cx + by*cy + bz*cz
        ac        = ax*cx + ay*cy + az*cz
        at        = ax*ax + ay*ay + az*az
        bt        = bx*bx + by*by + bz*bz
        ct        = cx*cx + cy*cy + cz*cz

        axb       = (at*bt)-(ab*ab)
        bxc       = (bt*ct)-(bc*bc)
*
        fnum      = (ab*bc)-(ac*bt)
        den       = axb*bxc
        if(den.gt.0.0d0) then 
*
          den       = dsqrt(den)         
Cosine of angle:
          co        = fnum/den
          CO        = DMIN1(CO, 1.D0)
          CO        = DMAX1(CO,-1.D0)
* Sign of angle:
      signum    = ax*(by*cz-cy*bz)+ay*(bz*cx-cz*bx)+az*(bx*cy-cx*by)
* Value of angle:
          arg       = dsign(dacos(co),signum)
	  else
	    arg=0.d0
	  end if    
	  NARG=0.5*(arg+PI)*NAA/PI+1
	  NPOP(ITYP,NARG)=NPOP(ITYP,NARG)+1 
	  end do
	end do
	end
*
*=================== MAKEPS ============================================
*                                                                       
	subroutine MAKEPS(filps,IX1,IX2,IY)
	include 'tranal.h'     
      character*2 color(0:maxcolor)
	character*12 filps
	character*80 com 
	data color/
     *   '0C', !  'bC', ! esli zadat' maxcolor==20,
     *   '1C', !  'cC', ! to nado ubrat' vosklicatel'nye
     *   '2C', !  'dC', ! znaki mezhdu dannymi
     *   '3C', !  'eC',
     *   '4C', !  'fC',
     *   '5C', !  'gC',
     *   '6C', !  'hC',
     *   '7C', !  'iC',
     *   '8C', !  'jC',
     *   '9C', !  'kC',
     *   'aC' /                        
	write(*,*)' Enter MAKEPS' 
	ICHAN=20
      open( ICHAN, file='tmp.ps', status='unknown' )
      write(20,*)IY,IX1,'(',NM(IS1(1)),') l-show'
      write(20,*)IY,IX2,'(',NM(IS2(1)),') l-show'
      do j=0,NTY
        m = -NTX
        IC = ITAB(j,1)
        do i=-NTX+1,NTX
          n = ITAB(j,i)
c n - eto uzhe No. tsveta ot 0 do maxcolor
          if( n .ne. IC ) then  
            write( 20, 100 )   j,    m, i-1, color(ic)
            IC = n
            m = i
          endif
        enddo
        write( 20, 100 )   j,    m, NTY, color(ic)
        write( 20, * )
      enddo
C      write(20,'(a)')'0 setgray'
      write(20,'(a)')'showpage'
      close( 20 )
100   format( i4, 1x, i4, 1x, i4, 1x, a2 )  
	com(1:19)='/bin/cp predlogpsf '
	com(20:31)=filps 
CI	call system(com(1:31))
	com(1:35)='cat tmp.ps >>                      '
	com(16:27)=filps
CI	call system(com(1:27))
	return
	end
*
*=================== MAKEPS2 ============================================
*                                                                       
	subroutine MAKEPS2(filps,IX1,IX2,IY)
	include 'tranal.h'     
      character color(0:maxcolor,0:maxcolor)*3,SYM(0:MAXCOLOR)*1
	character*12 filps
	character*80 com      
	data SYM /'0','1','2','3','4','5','6','7','8','9','a'/
	do I=0,MAXCOLOR
	  do J=0,MAXCOLOR
	    color(I,J)(1:1)=SYM(J)
	    color(I,J)(2:2)=SYM(I)
	    color(I,J)(3:3)='x'
	  end do
	end do
	write(*,*)' Enter MAKEPS' 
	ICHAN=20             
	MCL=MAXCOLOR+1
      open( ICHAN, file='tmp.ps', status='unknown' )
      do j=0,NTY
        m = -NTX
        IC = ITAB(j,1)
        do i=-NTX+1,NTX
          n = ITAB(j,i)
c n - eto uzhe No. tsveta ot 0 do maxcolor
          if( n .ne. IC ) then
	      I1C=mod(IC,MCL)
	      I2C=(IC-I1C)/MCL  
            if(I2C.le.MAXCOLOR)then
	        write( 20, 100 )   j,    m, i-1, color(I1C,I2C)
	      else
	        write( 20, 100 )   j,    m, i-1, 'xxx'
	      end if
            IC = n
            m = i
          endif
        enddo
	  I1C=mod(IC,MCL)
	  I2C=(IC-I1C)/MCL  
        if(I2C.le.MAXCOLOR)then
	    write( 20, 100 )   j,    m, NTY, color(I1C,I2C)
	  else
	    write( 20, 100 )   j,    m, NTY, 'xxx'
	  end if
        write( 20, * )
      enddo                              
	write(20,'(a)')'0 setgray'
	write(20,*)IY,IX1,'(',NM(IS1(1)),') l-show'
	write(20,*)IY,IX2,'(',NM(IS2(1)),') l-show'
	write(20,'(a)')'showpage'
      close( 20 )
100   format( i4, 1x, i4, 1x, i4, 1x, a3 )  
	com(1:23)='/usr/bin/cp color2psf '
	com(24:35)=filps 
*	call system(com(1:35))
	com(1:35)='cat tmp.ps >>                      '
	com(16:27)=filps
*	call system(com(1:27))
	return
	end
*
*======================= RDFCALC ==================================
*
      subroutine RDFCALC
C  calculate RDF
      include "tranal.h"
      do I=1,NRDF
	do K=1,IREP(I)
	  IS=IRD(I,K)
	  JS=JRD(I,K)
	  ITYP=ITS(IS)
	  JTYP=ITS(JS)
	  NIS=NSPEC(ITYP)
	  NJS=NSPEC(JTYP)
	  do IM=1,NIS                ! first molecule
	    JBEG=1
*	    if(ITYP.eq.JTYP)JBEG=IM
	    if(IS.eq.JS)JBEG=IM+1
	    ISHIFT=ISADDR(ITYP)+IS-ISADR(ITYP)-NSITS(ITYP)
	    do JM=JBEG,NJS
	      JSHIFT=ISADDR(JTYP)+JS-ISADR(JTYP)-NSITS(JTYP)
	      IST=ISHIFT+IM*NSITS(ITYP)
	      JST=JSHIFT+JM*NSITS(JTYP)
	      IMOL=NNUM(IST)
	      JMOL=NNUM(JST)
*		  write(*,*)I,K,IS,JS,IST,JST,NM(IS),NM(JS)
	      DX=SX(IST)-SX(JST)
	      DY=SY(IST)-SY(JST)
	      DZ=SZ(IST)-SZ(JST)
	      call PBC(DX,DY,DZ)
	      RR=sqrt(DX**2+DY**2+DZ**2)
	      if(IMOL.ne.JMOL)then
		NR=NA*RR/RDFCUT+1
		if(NR.gt.0.and.NR.le.NA)IRDF(I,NR)=IRDF(I,NR)+1
	      else
		NR=NAI*(RR-RMI)/DRI+1
*		write(*,'(7i6,f8.4)')I,K,IS,JS,IST,JST,NR,RR
		if(NR.gt.0.and.NR.le.NAI)IRDFI(I,NR)=IRDFI(I,NR)+1
	      end if
	    end do
	  end do
	end do
      end do
      return
      end
*
*======================= RDFOUT ====================================
*
      subroutine RDFOUT
      include "tranal.h"
      dimension TMP(MAXRDF)
      open(unit=16,file=FORDF,status='unknown')
      write(16,*)' Radial distribution functions'
      IFST=NA
      do K=1,NRDF
	 CONU=0.
	 NPAIR=0
	 NPRI=0                   ! intramolek. pairs
	 do KK=1,IREP(K)
	   IS=IRD(K,KK)
	   JS=JRD(K,KK)
	   ITYP=ITS(IS)
	   JTYP=ITS(JS)
	   NN1 = NSPEC(ITYP)
	   NN2 = NSPEC(JTYP)
	   if(ITYP.eq.JTYP)then
	     if(IS.eq.JS)then
	       NPAIR=NPAIR+NN1*(NN1-1)/2
	     else
	       NPAIR=NPAIR+NN1*(NN1-1)
	     end if
	   else
	     NPAIR=NPAIR+NN1*NN2
	   end if
	   if(ITYP.eq.JTYP.and.IS.ne.JS)NPRI=NPRI+1
	 end do
	 FACT=NDUP*VOL/(NPAIR*IAN)
	 write(16,*)
	 write(16,*)' This pair: ',NM(IS),' - ',NM(JS),
     +  '   Npairs=',NPAIR,'  Ninit=',NPRI
	 write(16,*)'------------------------------------'
	 do I=1,NA
	   RR=(I-0.5)*RDFCUT/NA
	   DRR=RDFCUT/NA
  	   SH12=4*PI*DRR*(RR**2+DRR**2/12.d0)
	   RDFV=IRDF(K,I)
	   CONU=CONU+RDFV*FACT/VOL
	   CONU1=CONU*NSPEC(ITS(IS))
	   CONU2=CONU*NSPEC(ITS(JS))
	   if(CONU.gt.1.d-8)then
	      write(16,'(f8.3,3f12.5,5x,a4,2x,a4,a1,a4)')
     +     RR,RDFV*FACT/SH12,CONU1,CONU2,'rdf:',NM(IS),'-',NM(JS)
	      if(I.lt.IFST)IFST=I
	   end if
	 end do
	 if(NPRI.ge.1)then
	   write(16,*)
	   write(16,*)' Intramolecular RDF: '
	   write(16,*)' ------------------- '
 	   FACT=NDUP*1.d0/(NSPEC(ITS(IS))*NPRI*IAN)
	   do I=1,NAI
	     RR=RMI+(I-0.5)*DRI/NAI
	     DRR=DRI/NAI
	     RDFV=IRDFI(K,I)*FACT/DRR
	     if(RDFV.gt.1.d-8)then
	      write(16,'(f8.3,f12.5,25x,a8,2x,a4,a1,a4)')
     +     RR,RDFV,'rdf_int:',NM(IS),'-',NM(JS)
	     end if
	   end do
	 end if
      end do
      write(16,*)' Gnuplot file:'
      write(16,*)'--------------- CUT HERE ---------------------'
	write(16,'(a1,7x,50(1x,a4,a1,a4))')
     +  '#',(NM(IRD(K,1)),'-',NM(JRD(K,1)),K=1,NRDF)
      do I=IFST,NA
	RR=(I-0.5)*RDFCUT/NA
	DRR=RDFCUT/NA
  	SH12=4*PI*DRR*(RR**2+DRR**2/12.d0)
        do K=1,NRDF
	 NPAIR=0
	 do KK=1,IREP(K)
	   IS=IRD(K,KK)
	   JS=JRD(K,KK)
	   if(IS.eq.JS)then
	     NPAIR=NPAIR+NSPEC(ITS(IS))*(NSPEC(ITS(JS))-1)/2
	   else
	     NPAIR=NPAIR+NSPEC(ITS(IS))*NSPEC(ITS(JS))
	   end if
	 end do
	 FACT=NDUP*VOL/(NPAIR*IAN)
	 TMP(K)=IRDF(K,I)*FACT/SH12
	end do
	write(16,'(f8.3,50f10.5)')RR,(TMP(K),K=1,NRDF)
      end do
      close(16)
      return
      end	    
*
*======================= PBC ========================================
*
      subroutine PBC(XX,YY,ZZ)
      include "tranal.h"
      if(XX.gt. HBOXL)XX=XX-BOXL
      if(XX.lt.-HBOXL)XX=XX+BOXL
      if(YY.gt. HBOYL)YY=YY-BOYL
      if(YY.lt.-HBOYL)YY=YY+BOYL
      if(ZZ.gt. HBOZL)ZZ=ZZ-BOZL
      if(ZZ.lt.-HBOZL)ZZ=ZZ+BOZL
      return
      end 
*
*======================= COLOR ==================================
*
	function NCOLOR(X,AMPL,MAXCOLOR)
	real*8 X,AMPL(MAXCOLOR)
	NCOLOR=0  
	do I=1,MAXCOLOR    
	  if(X.gt.AMPL(I))NCOLOR=I
	end do
	return
	end
*
*======================= COLOR2 ==================================
*
	function NCOLOR2(X,Y,AMPL,MAXCOLOR)
	real*8 X,Y,AMPL(MAXCOLOR)
	J=0
	K=0  
	do I=1,MAXCOLOR    
	  if(X.gt.AMPL(I))J=I
	  if(Y.gt.AMPL(I))K=I
	end do
	NCOLOR2=J*(MAXCOLOR+1)+K
	return
	end
*....
*======== XINTGR =======================================================
*....
      FUNCTION XINTGR(H,Y,NDIM)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION Y(0:NDIM)
      HT=H/3.0
      IF(NDIM.LT.5)RETURN
      SUM1=4.00*Y(1)
      SUM1=HT*(Y(0)+SUM1+Y(2))
      AUX1=4.00*Y(3)
      AUX1=SUM1+HT*(Y(2)+AUX1+Y(4))
      AUX2=HT*(Y(0)+3.8750*(Y(1)+Y(4))+2.6250*(Y(2)+Y(3))+Y(5))
      SUM2=4.00*Y(4)
      SUM2=AUX2-HT*(Y(3)+SUM2+Y(5))
      AUX=4.00*Y(2)
      IF(NDIM-6)5,5,2
    2 DO 4 I=6,NDIM,2
      SUM1=AUX1
      SUM2=AUX2
      AUX1=4.00*Y(I-1)
      AUX1=SUM1+HT*(Y(I-2)+AUX1+Y(I))
      IF(I-NDIM)3,6,6
    3 AUX2=4.00*Y(I)
      AUX2=SUM2+HT*(Y(I-1)+AUX2+Y(I+1))
    4 CONTINUE
    5 CONTINUE
      XINTGR=AUX2
      RETURN
    6 CONTINUE
      XINTGR=AUX1
      RETURN
      END                                       
*
*======================== RMSCALC =====================================
*
      SUBROUTINE RMSCALC
      include "tranal.h"
      DXA=0.
      DYA=0.
      DZA=0.
      DFI1=0.
      DFI2=0.
      NML=0
      DO ITYP=1,NTYPES
	if(IMAC(ITYP).EQ.1)THEN
	   do IS=ISADR(ITYP)+1,ISADR(ITYP+1)
	     I = ISADDR(ITYP)+IS-ISADR(ITYP)
	     DX=SX(I)-R(IS,1)
	     DY=SY(I)-R(IS,2)
	     DZ=SZ(I)-R(IS,3)
	     call PBC(DX,DY,DZ)
	     DXA=DXA+DX
	     DYA=DYA+DY
	     DZA=DZA+DZ
	     NML=NML+1
	   end do
	end if 
      end do
      if(NML.le.0)return
      DXA=DXA/NML
      DYA=DYA/NML
      DZA=DZA/NML
*  rotation
      NCHT=0
      DO ITYP=1,NTYPES
	if(IMAC(ITYP).EQ.1)THEN
	   do IS=ISADR(ITYP)+1,ISADR(ITYP+1)
	     I = ISADDR(ITYP)+IS-ISADR(ITYP)
	     X1 = R(IS,1)- DXA
	     X2 = SX(I)  - DXA
	     Y1 = R(IS,2)- DYA
	     Y2 = SY(I)  - DYA
	     Z1 = R(IS,3)- DZA
	     Z2 = SZ(I)  - DZA
	     call PBC(X1,Y1,Z1)
	     call PBC(X2,Y2,Z2)
	     ACS=(X1*X2+Y1*Y2)/sqrt((X1**2+Y1**2)*(X2**2+Y2**2))
	     FI1 = acos(ACS)
	     ZVC = X2*Y1-X1*Y2
	     if(FI1.gt.0.5*PI)NCHT=NCHT+1
	     if(ZVK.le.0)then
		FI1 =-FI1
	        FI2 = FI1+2.*PI
	     else
		FI2 = FI1
	     end if
	   end do
	end if
      end do
      if(NCHT.gt.NML)then
	FI=FI2/NML
      else
	FI=FI1/NML
      end if
      if(IPRINT.ge.6)write(*,'(a,5f12.7)')' DD: ',DXA,DYA,DZA,FI1,FI2
*   fitting and calculating RMS
      DO ITYP=1,NTYPES
	if(IMAC(ITYP).EQ.1)THEN
	   do IS=ISADR(ITYP)+1,ISADR(ITYP+1)
	     I = ISADDR(ITYP)+IS-ISADR(ITYP)
	     DZ=SZ(I)-R(IS,3)-DZA
	     X1 = R(IS,1)- DXA
	     X2 = SX(I)  - DXA
	     Y1 = R(IS,2)- DYA
	     Y2 = SY(I)  - DYA
	     X3 = X2*cos(FI)-Y2*sin(FI)
	     Y3 = X2*sin(FI)+Y2*cos(FI)
	     DX=X1-X3
	     DY=Y1-Y3
	     RMS = RMS + sqrt(DX**2+DY**2+DZ**2)
	   end do
	end if 
      end do
      RMS = RMS/NML
      if(IPRINT.ge.6)write(*,*)' RMS = ',sqrt(RMS)
      write(24,'(2f14.3)')(FULTIM-FULTIM0),sqrt(RMS)	
      RMSS = RMSS+RMS
      END
*
*======================== PDBDUMP =====================================
*                                                                      
	subroutine PDBDUMP(IPDB)
	include "tranal.h"
	character*10 FILPDB,NMR*3
	data IAC/0/
	FILPDB(1:5)='fort.'
	if(IPDB.lt.10)then
	  write(FILPDB(6:6),'(i1)')IPDB
	else if(IPDB.lt.100)then
	  write(FILPDB(6:7),'(i2)')IPDB
	else if(IPDB.lt.100)then
	  write(FILPDB(6:8),'(i3)')IPDB
      else
	  if(IAC.eq.0)write(*,*)' no more .pdb files'
	  IAC=1
	  return
	end if   
	open(unit=23,file=FILPDB,status='unknown')           
	NUNI=0
	do I=1,NSTOT                          
	  ITYP=ITYPE(I) 
	  NMR=NAMOL(ITYP)(1:3)
	  if(LIST(ITYP).ne.0.and.NMR.eq.'STR')then
	     if(NM(I)(1:3).eq.'O3*')NUNI=NUNI+1
	     write(23,'(a4,8x,a4,1x,a3,1x,a1,i4,4x,3f8.3)')
     +'ATOM',NM(I),NMR,NAMOL(ITYP)(4:4),NUNI,SX(I),SY(I),SZ(I)   
	  end if
	end do        
	IAB=0                                                   
	IAM=0
	do ITYP=1,NTYPES
	  NMR=NAMOL(ITYP)(1:3)
	  if(LIST(ITYP).ne.0.and.NMR.eq.'STR')then  
	    do II=IAB+1,IAB+NRB(ITYP)
	      write(23,'(a6,2i5)')'CONECT',IB(II)+IAM,JB(II)+IAM 
	    end do  
	    IAM=IAM+NSITS(ITYP)
        end if                                      
	  IAB=IAB+NRB(ITYP) 
	end do
	close(23)
	return
	end
*
*================ READMOL =============================================
*
*    Define molecule from DATABASE
	subroutine READMOL(SUMM,NX,NTYP,PATHDB,NAMN)
	include "tranal.h"
*
      DIMENSION CM(3)
	character PATHDB*62,namn*12,STR*80,FIL*80,TAKESTR*80,NAMH*4
        FIL=' '
	NX0=NX             
	IE=0
	IL=0 
	do I=1,62
	  ISTR=ichar(PATHDB(I:I))
	  if(ISTR.le.15)then
	    LD=I-1
	    go to 11
	  end if
        if(PATHDB(I:I).ne.' ')IL=I
	end do 
	LD=IL
 11	continue
	FIL(1:LD)=PATHDB(1:LD)
        FIL(LD+1:LD+1)='/'
	IL=0 
	do I=1,12
	  ISTR=ichar(NAMN(I:I))
	  if(ISTR.le.15)then
	    LN=I-1
	    go to 11
	  end if
        if(NAMN(I:I).ne.' ')IL=I
	end do 
	LN=IL
 12	continue
	FIL(LD+2:LD+LN+1)=NAMN(1:LN)
	FIL(LD+LN+2:LD+LN+5)='.mol'
	open(unit=12,file=fil,status='old',err=999)
	if(IPRINT.ge.5)then
	PRINT "(80('-'))"
      PRINT *
      PRINT * ,'*** MODEL ONE MOLECULE OF TYPE: ',NAMN,'  No.',NTYP
	end if
	STR=TAKESTR(12,IE)
	read(STR,*)NSTS
	if(IPRINT.ge.6)PRINT * ,'*** NR OF SITES:                ',NSTS
	if(NX+NSTS.gt.NS)
     & stop '!!! Increase NS (number of sites) in dimpar_tr.h'
	NSITS(NTYP)=NSTS
	NSBEG=NX+1
	do I=1,NSTS
	  STR=TAKESTR(12,IE)
	  IX=NX+I
	  NM(IX)=STR(1:4)
	  read(STR(5:80),*,err=903)(R(IX,J),J=1,3),
     +  MASS(IX),CHARGE(IX)
          if(IPRINT.ge.9)
     +      write(*,'(a5,a4,a4,3f7.3,a3,f8.4,a3,f6.3,a5,f8.4,a4,f9.4)')
     +      'atom ',NM(IX),'  R=',(R(IX,J),J=1,3),
     +      ' M=',MASS(IX),' Q=',CHARGE(IX),' si='
	end do
	NX=NX+NSTS
	NSEND=NX
* COM coordinates 
      SUMM       = 0.D0
      DO IS      = NSBEG,NSEND
        SUMM       = SUMM+MASS(IS)
      END DO! OF IS
*
      CM(1)      = 0.D0
      CM(2)      = 0.D0
      CM(3)      = 0.D0
      DO IS      = NSBEG,NSEND
        CM(1)      = CM(1)+R(IS,1)*MASS(IS)
        CM(2)      = CM(2)+R(IS,2)*MASS(IS)
        CM(3)      = CM(3)+R(IS,3)*MASS(IS)
      END DO! OF IS
*
      CM(1)      = CM(1)/SUMM
      CM(2)      = CM(2)/SUMM
      CM(3)      = CM(3)/SUMM
*     
*  Output of the reference
	STR=TAKESTR(12,IE)
	read(STR,*)NSR
	do I=1,NSR
	  read(12,'(a80)')STR
	  if(IPRINT.ge.8)write(*,'(a80)')STR
	end do
	if(IPRINT.ge.10)then
        PRINT *,'*** Molecular GEOMETRY (C.O.M. IN ORIGIN): '
        DO IS      = NSBEG,NSEND
          PRINT "('*** ',I4,3x,A4,3X,3(1X,F7.3))",
     +    IS,NM(IS),R(IS,1),R(IS,2),R(IS,3)
        END DO! OF IS
      end if
      return
 903	write(*,*)' Error in the list of atoms, line ',I
	stop
 902  write(*,*)' Error in the list of bonds, line ',K
	stop
 999  write(*,*)'!!! Molecule ',NAMN,' not found in the data base'
      write(*,*)'    File not found: ',FIL
	stop
	end 
*
*============== TAKESTR =========================================
*
      character*80 function TAKESTR(KAN,IE)
	character*80 AUX, fn*32 
	integer LCOUNT(256)   
	data LCOUNT /256*0/
	save AUX,LCOUNT           
	if(IE.eq.99)go to 10 
 1	LCOUNT(KAN)=LCOUNT(KAN)+1
 	read(KAN,'(a80)',err=10,end=20)AUX
	if(AUX(1:1).eq.'#')go to 1
	TAKESTR=AUX 
	IE=0
	return
 10	write(*,*)'!!! error in input file '   
	if(KAN.eq.5)then
	  write(*,*)' Standard input ' 
	else
	  inquire(unit=KAN,name=fn) 
	  write(*,*)' File ',fn
	end if
	write(*,*)' in line ',LCOUNT(KAN)
	write(*,*)AUX
	stop
 20	if(IE.ge.0)then
 	  write(*,*)'!!! end of file reached' 
	  if(KAN.eq.5)then
	    write(*,*)' Standard input ' 
	  else
	    inquire(unit=KAN,name=fn) 
	    write(*,*)' File ',fn
	  end if
	  stop
	end if  
	TAKESTR='  ' 
	IE=-1
	return
	end 
*
*================ LENG ===============================================
*
*	function LENG(STR,LS)
*	character*1 STR(LS)
*	IL=0 
*	do I=1,LS
*	  ISTR=ichar(STR(I))
*	  if(ISTR.le.15)then
*	    LENG=I-1
*	    return
*	  end if
*        if(STR(I).ne.' ')IL=I
*	end do 
*	LENG=IL
*	return
*      end   
*
*
*============= VECT =========================================
*	                                                       
	subroutine VECT(R1,R2,R3)
	real*8 R1(3),R2(3),R3(3)
	R3(1)= R1(2)*R2(3)-R1(3)*R2(2)
	R3(2)=-R1(1)*R2(3)+R1(3)*R2(1)
	R3(3)= R1(1)*R2(2)-R1(2)*R2(1) 
	return
	end
*
*================ NORM =======================================
*                                                             
	subroutine NORM(A,B,R,N)
	real*8 R,A(*),B(*) 
	R=0.d0
	do I=1,N
        R=R+A(I)**2
	end do       
	R=sqrt(R) 
	if(R.eq.0.d0)then
	  do I=1,N
	    B(I)=0.d0
	  end do
	else
	  do I=1,N
	    B(I)=A(I)/R
	  end do 
	end if
	return
	end
